/*
Plugin Name: Gallery from files
Plugin URI:  http://dovi42.hu/gallery-from-files
Description: Show gallery from file system.
Version:     0.05
Author:      Dovi42
Author URI:  http://dovi42.hu/
License:     GPLv2 or later
License URI: https://www.gnu.org/licenses/gpl-2.0.html
Text Domain: gallery-from-files
Generator:   WP Creator - http://wpcreator.hu - 2020-02-28 16:07:00
*/

/*
Átadott ajax változók: 
Passed ajax variables: 
-------------------------------------------: 
var gallery_from_files_variables_<token> = [
		'th_size'    : '200x200',
		'th_folder'  : '_thumbs',
		'page_limit' : '48',
		'order'      : 'set',
		'title'      : '1',
		'template'   : 'default'
		// Valamint azok a változók, amelyek a híváskor lettek definiálva 
		// Also, the variables that were defined at the time of the call 

		// Lásd: javascript a konzolt! 
		// See: javascript console! 
   ];
*/


var get_name_html_box = '';
var images_list = [];
var group_title = '';
var gauge_max = 0;
var cropdata;

jQuery(document).ready(function() {

    jQuery.noConflict();
    
    gallery_from_files_595_checkSelected();
    get_name_html_box = jQuery('#gallery_get_name').html();
    jQuery('#gallery_get_name').remove();

    jQuery('.sortable' ).sortable({
        placeholder: 'ui-state-highlight',
        forcePlaceholderSize: true,
        items: 'li:not(.sort-disabled)',
        start: function(e, ui) { 
            ui.placeholder.css({
                'visibility' : 'visible',
                'background-color' : '#FFFFD6'
            });
        },
        stop:  function (event, ui) {
            ui.item.find('a').off('click');
            gallery_from_files_595_saveGalleryOrder();
        }
    }).disableSelection();

    jQuery('[data-fancybox]').fancybox({
        caption : function( instance, item ) {
            var caption = jQuery(this).data('caption') || '';
            if ( item.type === 'image'  && caption != '') {
              caption = '<div class="fancybox-theme-caption">' + caption + '</div>' ;
            }
            return caption;
          }           
    });
    
    jQuery('.image-select').change(function() {
        gallery_from_files_595_checkSelected();
    });
    
    gallery_from_files_595_setGalleryMargins();

    jQuery("#images_upload").on('submit',(function(e) {
        e.preventDefault();
        
        gallery_from_files_595_gaugeInit(0);

        jQuery.ajax({
            url  : gallery_from_files_595_ajax_object.ajax_url,
            type : "POST",
            data :  new FormData(this),
            contentType: false,
            cache: false,
            processData:false,
            dataType : 'json',
            beforeSend : function() {
                //$("#preview").fadeOut();
                jQuery("#err").fadeOut();
            },
            success: function(data, result) {
                if (data.status == 1) {
                    jQuery('#myfile').val('');
                    location.reload();
                } else {
                    jQuery('#gallery-job-gauge').fadeOut();
                    gallery_from_files_595_hideOverlay();
                    var html = '<div class="alert alert-info" role="alert">'+data.message+'</div>';
                    jQuery("#err").html(html).fadeIn();
                    setTimeout(function(){ 
                        jQuery("#err").html('').fadeOut(); 
                    }, 5000);
                }
            },
            error: function(e) {
                jQuery("#err").html(e).fadeIn();
            }          
        });
    }));
    
    gallery_from_files_595_getShortcode();
    jQuery('.gallery_form_files_template').keyup(function(){
         gallery_from_files_595_getShortcode();
    });    
    jQuery('.gallery_form_files_template').change(function(){
         gallery_from_files_595_getShortcode();
    });    
    
});

jQuery( window ).on('resize', function(){
	gallery_from_files_595_resetGalleryMargins();
});

function gallery_from_files_595_getShortcode() {
    let text = '[gallery-from-files folder="'+jQuery('.code:first').attr('data-folder')+'" ';
 
    let tmpl = jQuery('select[name="gallery_form_files_template"] option:selected').val();
    text += 'template="'+tmpl+'"';

    text += ']'; 
    
    jQuery('.code').html(text);
}


function gallery_from_files_595_checkSelected() {
    var selected = true;
    jQuery('#images').children('li').each(function( index ) {
        if (jQuery(this).find('.image-select').prop('checked')) {
            selected = false;
        }
    });
    var buttons = ['button_delete_selected', 'button_rename_selected', 'button_rotate_left',
                   'button_rotate_right', 'button_resize_selected', 'button_thumbnail_selected',
                   'button_watermark_selected'];
    buttons.forEach(function(item, index) {
       jQuery('#'+item).prop('disabled', selected);    
    });
}

function gallery_from_files_595_showOverlay() {
    var over = '<div id="overlay" class="overlay" style="z-index:1000;"></div>';
    jQuery('body').prepend(over);
    jQuery('#overlay').width( jQuery(window).width() );
    jQuery('#overlay').height( jQuery(window).height() );
    jQuery('#overlay').fadeIn(200);
}

function gallery_from_files_595_hideOverlay() {
    jQuery('#overlay').fadeOut(200);
    setTimeout(function() {
        jQuery('#overlay').remove();
    }, 250);    
}

function gallery_from_files_595_showTitleBox(text, input) {

    var html = get_name_html_box;

    var box = '<div id="messageBox" class="messageBox" style="z-index:1001;">' 
            + html 
            + '</div>';

    gallery_from_files_595_showOverlay();
    jQuery('body').append( box );
    jQuery('.gallery_get_title_label').html(text);
    jQuery('#messageBox').find('.message_functions').prepend(input);
    var action = jQuery('#messageBox').find('.button-primary').attr('onclick'); 
//  jQuery('#messageBox').find('.button-primary').attr('onsubmit', action);
    jQuery('#messageBox').find('form').attr('action', 'javascript:' + action);

    var t = Math.floor((jQuery(window).height() - jQuery('#messageBox').height()) / 2);
    var l = Math.floor((jQuery(window).width() - jQuery('#messageBox').width()) / 2);
    jQuery('#messageBox').css('top', t + 'px');
    jQuery('#messageBox').css('left', l + 'px');
    jQuery('#messageBox').fadeIn();
    jQuery('.gallery_get_title_label:first').focus();
}

function gallery_from_files_595_hideTitleBox() {
    jQuery('#messageBox').hide();
    jQuery('#messageBox').remove();
    gallery_from_files_595_hideOverlay();
}



function gallery_from_files_595_saveGalleryOrder() {
    var list = [];
    jQuery('#folders').children('li').each(function( index ) {
        if (jQuery(this).attr('data-filename') != '[up]') {
            list.push( jQuery(this).attr('data-filename') );
        }
    });
    jQuery('#images').children('li').each(function( index ) {
        list.push( jQuery(this).attr('data-filename') );
    });

    var data = {
            action : 'gallery_from_files_595_js_sort_reorder',
            order  : JSON.stringify(list),
            path   : jQuery('#folders').attr('data-path')
        };
        
    jQuery.ajax({
        url      : gallery_from_files_595_ajax_object.ajax_url,
        dataType : 'json',
        type     : 'POST',
        data     : data,
        success  : function(data, result){
            if (data.status == 1) {
                // Status OK
                gallery_from_files_595_resetGalleryMargins();
            } else {
                alert(data.message);
            }
        } 
    });
}

function gallery_from_files_595_setGalleryMargins() {

    var gallery = jQuery('#gallery-content');
    var token   = 'gallery-from-files';
    
    var line = 1;
    var w = gallery.width();
    var line_width = 0;
    var cnt = 0;
    var margin = 0;
    
    gallery.find('li').each(function(){
        var img_w = jQuery(this).outerWidth();
        if ((line_width + jQuery(this).outerWidth()) < w) {
            line_width = line_width + img_w;
            jQuery(this).addClass(token + '-line-' + line);
            jQuery(this).attr('data-class', token + '-line-' + line);
            cnt++; 
        } else {
            cnt--;
            margin = Math.floor((w - line_width) / cnt);
            jQuery('.'+token + '-line-' + line).css('margin-right', margin + 'px');
            jQuery('.'+token + '-line-' + line + ':last').css('margin-right', '0px');
            line++;
            jQuery('<div class="clearfix" style="clear:both;"></div>').insertBefore(this);
            jQuery(this).addClass(token + '-line-' + line);
            jQuery(this).attr('data-class', token + '-line-' + line);
            cnt = 1;
            line_width = img_w;
        }                
    });    
    cnt--;
    var margin2 = Math.floor((w - line_width) / cnt);
    if (margin2 < margin) { margin = margin2; }
    if (margin == 0) { margin = 12; }
    jQuery('.'+token + '-line-' + line).css('margin-right', margin + 'px');
    jQuery('.'+token + '-line-' + line + ':last').css('margin-right', '0px');
}

function gallery_from_files_595_resetGalleryMargins() {

    var gallery = jQuery('#gallery-content');
    var token   = 'gallery-from-files';

	gallery.find('.clearfix').remove();
    gallery.find('li').each(function(){
        jQuery(this).removeClass( jQuery(this).attr('data-class') );
        jQuery(this).removeAttr('data-class');
        jQuery(this).css('margin-right', '0px');    
	});
    gallery_from_files_595_setGalleryMargins();
}

function gallery_from_files_595_js_setViewPath(path) {
    var host = window.location.host,
        exdate = new Date();
    exdate.setDate(exdate.getDate() + 365);
    document.cookie = 'gallery-from-files-path=' + path + ';  expires=' + exdate.toUTCString() + '; path=/; domain='+host;
    location.reload();
}

function gallery_from_files_595_new_folder_box()
{
    var input = '<input onclick="gallery_from_files_595_addNewFolder();" type="submit" class="button button-primary" value="'+gallery_lang['ADD']+'" />';
    gallery_from_files_595_showTitleBox(gallery_lang['NEW_FOLDER_LABEL'], input);    
}

function gallery_from_files_595_addNewFolder() {

    var title = jQuery('#gallery_get_title').val();
    gallery_from_files_595_hideTitleBox();

    if (title != null && title != '') {

        jQuery('#add_new_folder_icon').removeClass('dashicons-plus');
        jQuery('#add_new_folder_icon').addClass('dashicons-update');
        jQuery('#add_new_folder_icon').addClass('spin');

        var data = {
                action : 'gallery_from_files_595_js_new_folder',
                title  : title,
                path   : jQuery('#folders').attr('data-path')
            };
        
        jQuery.ajax({
            url      : gallery_from_files_595_ajax_object.ajax_url,
            dataType : 'json',
            type     : 'POST',
            data     : data,
            success  : function(data, result){

                jQuery('#add_new_folder_icon').removeClass('spin');
                jQuery('#add_new_folder_icon').removeClass('dashicons-update');
                jQuery('#add_new_folder_icon').addClass('dashicons-plus');

                if (data.status == 1) {
                    jQuery('#folders').append(data.html);
                    gallery_from_files_595_resetGalleryMargins();
                } else {
                    alert(data.message);
                }
            },
            error: function (request, status, error) {
                alert('AJAX error : ' + status);
            } 
        });
    }
}

function gallery_from_files_595_js_deleteFolder(item) {
    var id = item.closest('li').attr('id');
    jQuery('#'+id).find('.delete_folder_icon').html(gallery_wait);

    var data = {
            action   : 'gallery_from_files_595_js_delete_folder',
            filename : jQuery('#'+id).attr('data-filename'),
            path     : jQuery('#folders').attr('data-path')
        };

    jQuery.ajax({
        url      : gallery_from_files_595_ajax_object.ajax_url,
        dataType : 'json',
        type     : 'POST',
        data     : data,
        success  : function(data, result){

            if (data.status == 1) {
                jQuery('#'+id).fadeOut(500);
                setTimeout(function(){ 
                    jQuery('#'+id).remove();
                    gallery_from_files_595_resetGalleryMargins(); 
                }, 550);
            } else {
                jQuery('#'+data.id).find('.delete_folder_icon').html('<span class="dashicons dashicons-trash"></span>');
                alert(data.message);
            }
        },
        error: function (request, status, error) {
            alert('AJAX error : ' + status);
        } 
    });
}

function gallery_from_files_595_my_trim(text) {
    text = text.replace('[', '');
    text = text.replace(']', '');
    text = text.replace('<br>', '|');
    text = text.replace('<br />', '|');
    text = text.replace("\n", '|');
    console.log(text);
    return text;
}

function gallery_from_files_595_edit_folder_box(item)
{
    var id = item.closest('li').attr('id');
    var title = jQuery('#'+id).find('.gallery-from-files-thumbnail-title:first').html();
    title = gallery_from_files_595_my_trim(title);
    
    var input = '<input onclick="gallery_from_files_595_editFolderTitle();" type="button" class="button button-primary" value="'+gallery_lang['RENAME']+'" />'
              + '<input id="edited_id" type="hidden" value="'+id+'" />'
              + '<input id="edited_title" type="hidden" value="'+title+'" />';
    gallery_from_files_595_showTitleBox(gallery_lang['EDIT_TITLE_LABEL'], input);    
    jQuery('#gallery_get_title').val(title);
}

function gallery_from_files_595_editFolderTitle() {

    var id        = jQuery('#edited_id').val();
    var title     = jQuery('#edited_title').val();
    var new_title = jQuery('#gallery_get_title').val();
    gallery_from_files_595_hideTitleBox();

    if (new_title != null && new_title != '' && new_title != title ) {

        jQuery('#'+id).find('.edit_folder_icon').html(gallery_wait);

        var data = {
                action   : 'gallery_from_files_595_edit_description',
                id       : id,
                title    : new_title,
                filename : jQuery('#'+id).attr('data-filename'),
                path     : jQuery('#folders').attr('data-path')
            };
    
        jQuery.ajax({
            url      : gallery_from_files_595_ajax_object.ajax_url,
            dataType : 'json',
            type     : 'POST',
            data     : data,
            success  : function(data, result){

                jQuery('#'+data.id).find('.edit_folder_icon').html('<span class="dashicons dashicons-admin-comments"></span>');

                if (data.status == 1) {
                    jQuery('#'+data.id).find('.gallery-from-files-thumbnail-title').html(data.title.replace('|', '<br />'));
                    jQuery('#'+data.id).attr('data-filename', data.filename);
                } else {
                    alert(data.message);
                }
            },
            error: function (request, status, error) {
                alert('AJAX error : ' + status);
            } 
        });
    }    
}

function gallery_from_files_595_edit_image_box(item)
{
    var id = item.closest('li').attr('id');
    var title = jQuery('#'+id).find('.gallery-from-files-thumbnail-title:first').html();
    title = gallery_from_files_595_my_trim(title);
    
    var input = '<input onclick="gallery_from_files_595_editFolderTitle();" type="button" class="button button-primary" value="'+gallery_lang['RENAME']+'" />'
              + '<input id="edited_id" type="hidden" value="'+id+'" />'
              + '<input id="edited_title" type="hidden" value="'+title+'" />';
    gallery_from_files_595_showTitleBox(gallery_lang['EDIT_IMAGE_TITLE'], input);    
    jQuery('#gallery_get_title').val(title);
}

function gallery_from_files_595_select_all() {
    jQuery('#images').children('li').each(function( index ) {
        jQuery(this).find('.image-select').prop('checked', true);
    });
    gallery_from_files_595_checkSelected();
}

function gallery_from_files_595_unselect_all() {
    jQuery('#images').children('li').each(function( index ) {
        jQuery(this).find('.image-select').prop('checked', false);
    });
    gallery_from_files_595_checkSelected();
}

function gallery_from_files_595_getSelected() {
    var ids = [];
    jQuery('#images').children('li').each(function( index ) {
        if (jQuery(this).find('.image-select').prop('checked')) {
            ids.push( jQuery(this).attr('id') );
        }
    });
    if (ids.length == 0) {
        alert( gallery_lang['NEED_SELECTED_IMAGES'] );        
    } else {
        images_list = ids;
    }
}

function gallery_from_files_595_gaugeInit(max) {
    if (max == '' || Number(max) < 1) {
        jQuery('#gallery-job-gauge').find('.gauge-line').hide();
        jQuery('#gallery-job-gauge').find('.percent').hide();
        jQuery('#gallery-job-gauge').find('.wait-image').show();
    } else {
        gauge_max = Number(max);
        jQuery('#gallery-job-gauge').find('.gauge').width(0);
        jQuery('#gallery-job-gauge').find('.gauge-line').show();
        jQuery('#gallery-job-gauge').find('.percent').html('0%');
        jQuery('#gallery-job-gauge').find('.percent').show();
        jQuery('#gallery-job-gauge').find('.wait-image').hide();
    }
    gallery_from_files_595_showOverlay();
    var t = Math.floor((jQuery(window).height() - jQuery('#gallery-job-gauge').height()) / 2);
    var l = Math.floor((jQuery(window).width() - jQuery('#gallery-job-gauge').width()) / 2);
    jQuery('#gallery-job-gauge').css('top', t + 'px');
    jQuery('#gallery-job-gauge').css('left', l + 'px');
    jQuery('#gallery-job-gauge').fadeIn();
}

function gallery_from_files_595_gaugeUpdate(percent) {
    percent = Number(percent);
    percent = percent / (gauge_max / 100);
    percent = 100 - Math.round(percent);
    jQuery('#gallery-job-gauge').find('.percent').html(percent + '%');
    jQuery('#gallery-job-gauge').find('.gauge').width((percent * 2));
    if (percent >= 100) {
        gallery_from_files_595_hideOverlay();
        jQuery('#gallery-job-gauge').fadeOut();
    }
}
function gallery_from_files_595_gaugeHide() {
    gallery_from_files_595_hideOverlay();
    jQuery('#gallery-job-gauge').fadeOut();
}


function gallery_from_files_595_groupTitles() {
    
    gallery_from_files_595_getSelected();

    if (images_list.length < 1) {
        return false;
    }
    
    var input = '<input onclick="gallery_from_files_595_set_group_titles();" type="button" class="button button-primary" value="'+gallery_lang['RENAME']+'" />';
    gallery_from_files_595_showTitleBox(gallery_lang['SELECTED_IMAGES_TITLE'], input);    
}

function gallery_from_files_595_set_group_titles() {
    group_title = jQuery('#gallery_get_title').val();
    gallery_from_files_595_hideTitleBox();

    if (images_list.length < 1) {
        return false;
    }

    gallery_from_files_595_gaugeInit(0);

    jQuery('#group_title_icon').removeClass('dashicons-admin-comments');
    jQuery('#group_title_icon').addClass('dashicons-update');
    jQuery('#group_title_icon').addClass('spin');

    var files = []; 
    images_list.forEach(function(id) {
        files.push( jQuery('#'+id).attr('data-filename') );
    });
    var path = jQuery('#images').attr('data-path');

    var data_tmp = {action : 'gallery_from_files_595_group_filename',
                    title    : group_title,
                    path     : path,
                    files    : files,
                    group    : images_list};
    jQuery.ajax({
        url      : gallery_from_files_595_ajax_object.ajax_url,
        dataType : 'json',
        type     : 'POST',
        data     : data_tmp,
        success  : function(res, result){
            if (res.status == 1) {

                res.group.forEach(function(item) {
                    var id = '#'+item.id;
                    jQuery(id).find('.image-select').prop('checked', false);
                    jQuery(id).attr('data-filename', item.filename);
                    jQuery(id).find('.gallery-from-files-thumbnail-title').html( res.title.replace('|', '<br />') );
                    jQuery(id).find('a.image-link').attr('data-caption', res.title);
                    jQuery(id).find('a.image-link').attr('href', item.url);
    
                    var thumbs = item.thumbs; 
                    thumbs.forEach(function(th) {
                        jQuery(id).find('a.'+th.cl+':first').attr('href', th.url);
                        jQuery(id).find('a.'+th.cl+':first').attr('data-caption', th.cl);
                    });
                });

                jQuery('#group_title_icon').removeClass('spin');
                jQuery('#group_title_icon').removeClass('dashicons-update');
                jQuery('#group_title_icon').addClass('dashicons-admin-comments');
                
                gallery_from_files_595_gaugeHide();

            } else {
                alert(res.message);
            }
        },
        error: function (request, status, error) {
            alert('AJAX error : ' + status);
        } 
    });

    // gallery_from_files_595_set_one_title();
}

function gallery_from_files_595_set_one_title() {

    if (images_list.length < 1) {
        return false;
    }
    var id = images_list[0];
    images_list.splice(0, 1);

    var filename = jQuery('#'+id).attr('data-filename');
    var path = jQuery('#images').attr('data-path');
    
    var data_tmp = {action : 'gallery_from_files_595_edit_description',
                    id       : id,
                    title    : group_title,
                    path     : path,
                    filename : filename};
    jQuery.ajax({
        url      : gallery_from_files_595_ajax_object.ajax_url,
        dataType : 'json',
        type     : 'POST',
        data     : data_tmp,
        success  : function(data, result){
            if (data.status == 1) {
                jQuery('#'+data.id).find('.image-select').prop('checked', false);
                jQuery('#'+data.id).attr('data-filename', data.filename);

                jQuery('#'+data.id).find('.gallery-from-files-thumbnail-title').html( data.title );
                gallery_from_files_595_gaugeUpdate(images_list.length);

                if (images_list.length < 1) {
                    jQuery('#group_title_icon').removeClass('spin');
                    jQuery('#group_title_icon').removeClass('dashicons-update');
                    jQuery('#group_title_icon').addClass('dashicons-admin-comments');
                    gallery_from_files_595_saveGalleryOrder();
                } else {
                    gallery_from_files_595_set_one_title();    
                }

            } else {
                alert(data.message);
            }
        },
        error: function (request, status, error) {
            alert('AJAX error : ' + status);
        } 
    });
}

function gallery_from_files_595_rotateLeft() {

    gallery_from_files_595_getSelected();

    if (images_list.length < 1) {
        return false;
    }

    jQuery('#rotate_left_icon').removeClass('dashicons-image-rotate-left');
    jQuery('#rotate_left_icon').addClass('dashicons-update');
    jQuery('#rotate_left_icon').addClass('spin');

    gallery_from_files_595_gaugeInit(images_list.length);
    gallery_from_files_595_rotateImage('left');
}

function gallery_from_files_595_rotateRight() {

    gallery_from_files_595_getSelected();

    if (images_list.length < 1) {
        return false;
    }

    jQuery('#rotate_right_icon').removeClass('dashicons-image-rotate-right');
    jQuery('#rotate_right_icon').addClass('dashicons-update');
    jQuery('#rotate_right_icon').addClass('spin');

    gallery_from_files_595_gaugeInit(images_list.length);
    gallery_from_files_595_rotateImage('right');
}

function gallery_from_files_595_rotateImage(mode) {
    if (images_list.length < 1) {
        return false;
    }

    var id = images_list[0];
    images_list.splice(0, 1);
    
    var filename = jQuery('#'+id).attr('data-filename');
    var path = jQuery('#images').attr('data-path');

    var data = {
            action : 'gallery_from_files_595_rotate_image',
            id       : id,
            path     : path,
            filename : filename,
            mode     : mode
        };

    jQuery.ajax({
        url      : gallery_from_files_595_ajax_object.ajax_url,
        dataType : 'json',
        type     : 'POST',
        data     : data,
        success  : function(data, result){
            if (data.status == 1) {

                jQuery('#'+data.id).find('.image-select').prop('checked', false);
                var d = new Date();
                jQuery('#'+data.id).find('.image-link').attr('href', data.image + '?'+d.getTime());
                jQuery('#'+data.id).find('.thumbnail-link').attr('src', data.thumbnail + '?'+d.getTime());

                gallery_from_files_595_gaugeUpdate(images_list.length);
                if (images_list.length < 1) {
                    jQuery('#rotate_'+data.mode+'_icon').removeClass('dashicons-update');
                    jQuery('#rotate_'+data.mode+'_icon').removeClass('spin');
                    jQuery('#rotate_'+data.mode+'_icon').addClass('dashicons-image-rotate-'+data.mode);
                } else {
                    gallery_from_files_595_rotateImage(data.mode)
                }
            } else {
                alert(data.message);
            }
        },
        error: function (request, status, error) {
            alert('AJAX error : ' + status);
        } 
    });
}


function gallery_from_files_595_resize() {

    gallery_from_files_595_getSelected();

    if (images_list.length < 1) {
        return false;
    }

    jQuery('#group_resize_icon').removeClass('dashicons-image-crop');
    jQuery('#group_resize_icon').addClass('dashicons-update');
    jQuery('#group_resize_icon').addClass('spin');

    gallery_from_files_595_gaugeInit(images_list.length);
    gallery_from_files_595_resizeImage();
}

function gallery_from_files_595_resizeImage() {
    if (images_list.length < 1) {
        return false;
    }

    var id = images_list[0];
    images_list.splice(0, 1);
    
    var filename = jQuery('#'+id).attr('data-filename');
    var path = jQuery('#images').attr('data-path');

    var data = {
            action : 'gallery_from_files_595_resize_image',
            id       : id,
            path     : path,
            filename : filename
        };

    jQuery.ajax({
        url      : gallery_from_files_595_ajax_object.ajax_url,
        dataType : 'json',
        type     : 'POST',
        data     : data,
        success  : function(data, result){
            if (data.status == 1) {

                jQuery('#'+data.id).find('.image-select').prop('checked', false);
                var d = new Date();
                jQuery('#'+data.id).find('.image-link:first').attr('href', data.image + '?'+d.getTime());
                jQuery('#'+data.id).find('.thumbnail-link:first').attr('src', data.thumbnail+'?'+d.getTime());
                jQuery('#'+data.id).find('.size-info:first').html(data.size);

                gallery_from_files_595_gaugeUpdate(images_list.length);
                if (images_list.length < 1) {
                    jQuery('#group_resize_icon').removeClass('dashicons-update');
                    jQuery('#group_resize_icon').removeClass('spin');
                    jQuery('#group_resize_icon').addClass('dashicons-image-crop');
                } else {
                    gallery_from_files_595_resizeImage()
                }
            } else {
                alert(data.message);
            }
        },
        error: function (request, status, error) {
            alert('AJAX error : ' + status);
        } 
    });
}

function gallery_from_files_595_generateThumbnails() {

    gallery_from_files_595_getSelected();

    if (images_list.length < 1) {
        return false;
    }

    jQuery('#generate_thumbnail_icon').removeClass('dashicons-format-gallery');
    jQuery('#generate_thumbnail_icon').addClass('dashicons-update');
    jQuery('#generate_thumbnail_icon').addClass('spin');

    gallery_from_files_595_gaugeInit(images_list.length);
    gallery_from_files_595_generate_thumbnail();
}

function gallery_from_files_595_generate_thumbnail() {
    if (images_list.length < 1) {
        return false;
    }

    var id = images_list[0];
    images_list.splice(0, 1);
    
    var filename = jQuery('#'+id).attr('data-filename');
    var path = jQuery('#images').attr('data-path');

    var data = {
            action : 'gallery_from_files_595_generate_thumbnail',
            id       : id,
            path     : path,
            filename : filename
        };

    jQuery.ajax({
        url      : gallery_from_files_595_ajax_object.ajax_url,
        dataType : 'json',
        type     : 'POST',
        data     : data,
        success  : function(data, result){
            if (data.status == 1) {

                jQuery('#'+data.id).find('.image-select').prop('checked', false);
                var d = new Date();
                jQuery('#'+data.id).find('.image-link').attr('href', data.image + '?'+d.getTime());
                jQuery('#'+data.id).find('.thumbnail-link').attr('src', data.thumbnail + '?'+d.getTime());

                gallery_from_files_595_gaugeUpdate(images_list.length);
                if (images_list.length < 1) {
                    jQuery('#generate_thumbnail_icon').removeClass('dashicons-update');
                    jQuery('#generate_thumbnail_icon').removeClass('spin');
                    jQuery('#generate_thumbnail_icon').addClass('dashicons-format-gallery');
                } else {
                    gallery_from_files_595_generate_thumbnail()
                }
            } else {
                alert(data.message);
            }
        },
        error: function (request, status, error) {
            alert('AJAX error : ' + status);
        } 
    });
    
}

function gallery_from_files_595_generateWatermarks() {
    gallery_from_files_595_getSelected();

    if (images_list.length < 1) {
        return false;
    }

    jQuery('#generate_watermark_icon').removeClass('dashicons-format-image');
    jQuery('#generate_watermark_icon').addClass('dashicons-update');
    jQuery('#generate_watermark_icon').addClass('spin');

    gallery_from_files_595_gaugeInit(images_list.length);
    gallery_from_files_595_generate_watermark();
    
}

function gallery_from_files_595_generate_watermark() {

    if (images_list.length < 1) {
        return false;
    }

    var id = images_list[0];
    images_list.splice(0, 1);
    
    var filename = jQuery('#'+id).attr('data-filename');
    var path = jQuery('#images').attr('data-path');

    var data = {
            action : 'gallery_from_files_595_generate_watermark',
            id       : id,
            path     : path,
            filename : filename
        };

    jQuery.ajax({
        url      : gallery_from_files_595_ajax_object.ajax_url,
        dataType : 'json',
        type     : 'POST',
        data     : data,
        success  : function(data, result){
            if (data.status == 1) {

                jQuery('#'+data.id).find('.image-select').prop('checked', false);
                var d = new Date();
                jQuery('#'+data.id).find('.image-link').attr('href', data.image + '?'+d.getTime());
                jQuery('#'+data.id).find('.thumbnail-link').attr('src', data.thumbnail + '?'+d.getTime());

                gallery_from_files_595_gaugeUpdate(images_list.length);
                if (images_list.length < 1) {
                    jQuery('#generate_watermark_icon').removeClass('dashicons-update');
                    jQuery('#generate_watermark_icon').removeClass('spin');
                    jQuery('#generate_watermark_icon').addClass('dashicons-format-image');
                } else {
                    gallery_from_files_595_generate_watermark()
                }
            } else {
                gallery_from_files_595_gaugeUpdate(0);
                alert(data.message);
            }
        },
        error: function (request, status, error) {
            alert('AJAX error : ' + status);
        } 
    });
    
}

function gallery_from_files_595_selected_delete() {
    gallery_from_files_595_getSelected();

    if (images_list.length < 1) {
        return false;
    }

    jQuery('#group_delete_icon').removeClass('dashicons-trash');
    jQuery('#group_delete_icon').addClass('dashicons-update');
    jQuery('#group_delete_icon').addClass('spin');

    gallery_from_files_595_gaugeInit(images_list.length);
    gallery_from_files_595_delete_image();
}

function gallery_from_files_595_delete_image() {

    if (images_list.length < 1) {
        return false;
    }

    var id = images_list[0];
    images_list.splice(0, 1);
    
    var filename = jQuery('#'+id).attr('data-filename');
    var path = jQuery('#images').attr('data-path');

    var data = {
            action : 'gallery_from_files_595_delete_image',
            id       : id,
            path     : path,
            filename : filename
        };

    jQuery.ajax({
        url      : gallery_from_files_595_ajax_object.ajax_url,
        dataType : 'json',
        type     : 'POST',
        data     : data,
        success  : function(data, result){
            if (data.status == 1) {

                jQuery('#'+data.id).fadeOut(200);
                setTimeout(function(){ 
                    jQuery('#'+data.id).remove();
                }, 250);

                gallery_from_files_595_gaugeUpdate(images_list.length);
                if (images_list.length < 1) {
                    jQuery('#group_delete_icon').removeClass('dashicons-update');
                    jQuery('#group_delete_icon').removeClass('spin');
                    jQuery('#group_delete_icon').addClass('dashicons-trash');
                    
                    gallery_from_files_595_resetGalleryMargins();
                    gallery_from_files_595_checkSelected();
                } else {
                    gallery_from_files_595_delete_image();
                }
            } else {
                gallery_from_files_595_gaugeUpdate(0);
                alert(data.message);
            }
        },
        error: function (request, status, error) {
            alert('AJAX error : ' + status);
        } 
    });
}

function gallery_from_files_595_showCoords(c)
{
    cropdata = {
        left:   c.x,
        top:    c.y,
        width:  c.w,
        height: c.h
    };
    if (c.w !== 'undefined' && c.w != 'NaN') {
        jQuery('#crop-info').html(Math.round(c.w)+'x'+Math.round(c.h));
    }
};

function gallery_from_files_595_get_size(size, target) {
    
    var size = size.split('x');
    var landscape = true;
    if (Number(size[1]) > Number(size[0])) {
        landscape = false;
    }     
    target = target.split('x');
    var t_landscape = true;
    if (Number(target[1]) > Number(target[0])) {
        t_landscape = false;
    }    
    if (landscape != t_landscape) {
        return target[1]+'x'+target[0];
    }
    return target[0]+'x'+target[1];
}

function gallery_from_files_595_cropImage(item) {
  
    var id = item.closest('li').attr('id');
      
    jQuery('#crop-image-path').val( jQuery('#folders').attr('data-path') );
    jQuery('#crop-image-name').val( jQuery('#'+id).attr('data-filename') );
    jQuery('#crop-image-id').val( id );
    image = jQuery('#'+id).find('.image-link:first').attr('href');
    
    var size = gallery_from_files_595_get_size(jQuery('#'+id).attr('data-w')+'x'+jQuery('#'+id).attr('data-h'),  gallery_from_files_ajax_vars.size);
    console.log(size);
    
    cropdata = {};

    gallery_from_files_595_showOverlay();
    gallery_from_files_595_gaugeInit(0);

    var img = document.createElement('img');
    img.setAttribute('id', 'gallery_from_files_jcrop_target');
    img.setAttribute('src', image);
    img.setAttribute('style', 'width:100%;');
    img.setAttribute('data-size', size);
    jQuery('#gallery_crop_image').prepend(img);
    img.onload = function() {
        jQuery('#gallery_crop_image').prepend(img);

        gallery_from_files_595_gaugeHide();

        size = size.split('x');
        jcrop_api = jQuery.Jcrop('#gallery_from_files_jcrop_target', {
            onChange:    gallery_from_files_595_showCoords,
    		onSelect:    gallery_from_files_595_showCoords,
            bgColor:     'black',
            bgOpacity:   .4,
            setSelect:   [ 0, 0, size[0], size[1] ],
            aspectRatio: size[0] / size[1],
            boxWidth:    600,
            boxHeight:   400
        });
        jQuery('#gallery_crop_image').fadeIn();

        var t = Math.floor((jQuery(window).height() - jQuery('#gallery_crop_image').height()) / 2);
        var l = Math.floor((jQuery(window).width() - jQuery('#gallery_crop_image').width()) / 2);
        jQuery('#gallery_crop_image').css('top', t + 'px');
        jQuery('#gallery_crop_image').css('left', l + 'px');
    };    

    var t = Math.floor((jQuery(window).height() - jQuery('#gallery_crop_image').height()) / 2);
    var l = Math.floor((jQuery(window).width() - jQuery('#gallery_crop_image').width()) / 2);
    jQuery('#gallery_crop_image').css('top', t + 'px');
    jQuery('#gallery_crop_image').css('left', l + 'px');

}

function gallery_from_files_595_saveCropImage() {
    
    var data_tmp = {action : 'gallery_from_files_595_save_crop_impage',
                    path     : jQuery('#crop-image-path').val(),
                    filename : jQuery('#crop-image-name').val(),
                    id       : jQuery('#crop-image-id').val(),
                    data     : cropdata};
    
    gallery_from_files_595_hideOverlay();
    jQuery('#gallery_crop_image').fadeOut();
    jcrop_api.destroy();
    jQuery('#gallery_from_files_jcrop_target').remove();
    
    gallery_from_files_595_gaugeInit(0);    
    
    jQuery.ajax({
        url      : gallery_from_files_595_ajax_object.ajax_url,
        dataType : 'json',
        type     : 'POST',
        data     : data_tmp,
        success  : function(data, result){
            if (data.status == 1) {
                gallery_from_files_595_gaugeHide();
                var d = new Date();
                jQuery('#'+data.id).find('.thumbnail-link:first').attr('src', data.thumbnail+'?'+d.getTime());
                var src = jQuery('#'+data.id).find('.image-link:first').attr('href');
                jQuery('#'+data.id).find('.image-link:first').attr('href', src+'?'+d.getTime());
                jQuery('#'+data.id).find('.size-info:first').html(data.size);
            }
        },
        error: function (request, status, error) {
            alert('AJAX error : ' + status);
        } 
    });
}

function gallery_from_files_595_hide_crop() {
    gallery_from_files_595_hideOverlay();
    jQuery('#gallery_crop_image').fadeOut();

    setTimeout(function(){
        jcrop_api.destroy();
        jQuery('#gallery_from_files_jcrop_target').remove();
    }, 500);
}

function gallery_from_files_595_copy_image_to_clipboard(item) {

    item.find('.dashicons').toggleClass('dashicons-shortcode dashicons-update-alt').addClass('spin');

    let variables = [
            'gallery-from-files',
            'folder="'+jQuery('.code:first').attr('data-folder')+'"',
            'template="'+jQuery('select[name="gallery_form_files_template"] option:selected').val()+'"'
        ];

    let image = item.closest('li');
    variables.push( 'counter="'+image.attr('data-counter')+'"' );
    variables.push( 'image="'+image.attr('data-filename')+'"' );

    text = '[' + variables.join(' ') + ']';

    var temp = jQuery("<input>");
    jQuery("body").append(temp);
    temp.val(text).select();
    document.execCommand("copy");
    temp.remove();    
    
    setTimeout(function() {
        jQuery('.spin').toggleClass('dashicons-shortcode dashicons-update-alt').removeClass('spin');
    }, 100); 
}

function gallery_from_files_595_copy_to_clipboard() {

    jQuery('.shortcode').find('.dashicons').toggleClass('dashicons-shortcode dashicons-update-alt').addClass('spin');

    text = jQuery('.shortcode').find('.code:first').text();
    var temp = jQuery("<input>");
    jQuery("body").append(temp);
    temp.val(text).select();
    document.execCommand("copy");
    temp.remove();    

    setTimeout(function() {
        jQuery('.spin').toggleClass('dashicons-shortcode dashicons-update-alt').removeClass('spin');
    }, 100); 

}
