<?php
/*
Plugin Name: Gallery from files
Plugin URI:  http://wpdemo.dovi42.hu/gallery-from-files-en/
Description: Show gallery from file system.
Version:     1.60
Author:      Dovi42
Author URI:  http://dovi42.hu/
License:     GPLv2 or later
License URI: https://www.gnu.org/licenses/gpl-2.0.html
Text Domain: gallery-from-files
Generator:   WP Creator - http://wpcreator.hu - 2020-02-28 16:07:00
*/

if ( !defined( 'ABSPATH' ) ) exit;

if (!defined('DS')) { define( 'DS', DIRECTORY_SEPARATOR ); }

define('GALLERY_FROM_FILES_595_VERSION', '1.60');
define('GALLERY_FROM_FILES_595_ROOT', dirname(__FILE__));

if (!defined('GALLERY_FROM_FILES_595_WP_ROOT')) {
    $path = explode(DS, GALLERY_FROM_FILES_595_ROOT);    
    $path = array_slice($path, 0, -3);
    $path = implode(DS, $path).DS;
    define('GALLERY_FROM_FILES_595_WP_ROOT', $path);
}


function gallery_from_files_595_get_options() { 
	// Alapértelmezett értékek beállítása
	// Set default option values
	$defaults = array(
			'size'       => '800x600',
			'auto'       => '1',
            'th_size'    => '200x200',
			'th_folder'  => '_thumbs',
			'page_limit' => 24,
			'order'      => 'set',
			'orderby'    => 'asc',
			'fancy'      => '1',
			'title'      => '1',
			'template'   => 'default',
			'watermark'  => '',
			'webp'       => '1', 
            'compress'   => 90,
            'folder'     => '',
            'rename'     => '1',
		);

	// Beállított értékek beolvasása
	// Get the set plugin option values
	$options = get_option('gallery_from_files_options');

	// Ha nincs beállítva, akkor az alapértelmezett érték 
	// If not set then set the default 
	$options = wp_parse_args($options, $defaults);

	return $options;
}


function gallery_from_files_595_load_textdomain() {
    load_plugin_textdomain( 'gallery-from-files', false, basename( GALLERY_FROM_FILES_595_ROOT ) . '/languages' ); 
}
add_action( 'plugins_loaded', 'gallery_from_files_595_load_textdomain' );

// Show notice 
// Üzenet megjelenítése
function gallery_from_files_595_notices() {

    if( get_transient( 'gallery_from_files_595_review_notice' ) ) {

        echo '<div class="notice notice-success"><p>' . 
                sprintf( '<strong>'.__('Gallery from files','gallery-from-files').':</strong> '.
                         __('Please don\'t forget to <a href="%s" target="_blank">rate the plugin!</a>', 'gallery-from-files'),
                        'https://wordpress.org/support/plugin/gallery-from-files/reviews/') .
             '</p></div>';
        delete_transient( 'gallery_from_files_595_review_notice' );
    }
}
add_action( 'admin_notices', 'gallery_from_files_595_notices' );


function gallery_from_files_595_activation() {
    // A plugin aktiválásakor fut le
    // Call when plugin is activated
    
	// Alapértelmezett értékek beállítása
	// Set default value(s) to options
	$options = gallery_from_files_595_get_options();
	update_option('gallery_from_files_options', $options, true);
    
    set_transient( 'gallery_from_files_595_review_notice', 1 );
    
    // flush_rewrite_rules();
}
register_activation_hook( __file__, 'gallery_from_files_595_activation' );

function gallery_from_files_595_deactivation() {
    // A plugin deaktiválásakor fut le
    // Call when plugin is deactivated

	// Beállítások törlése
	// Delete value(s) from options
	delete_option('gallery_from_files_options');

    // flush_rewrite_rules();
}
register_deactivation_hook( __file__, 'gallery_from_files_595_deactivation' );

function gallery_from_files_595_uninstall() {
    // A plugin törlésekor fut le
    // Call when plugin is uninstall

}
register_uninstall_hook( __file__, 'gallery_from_files_595_uninstall' );

function gallery_from_files_595_upgrade_completed( $upgrader_object, $options ) {
    $our_plugin = plugin_basename( __file__ );
    if( $options['action'] == 'update' && $options['type'] == 'plugin' && isset( $options['plugins'] ) ) {
        foreach( $options['plugins'] as $plugin ) {
            if( $plugin == $our_plugin ) {

                set_transient( 'gallery_from_files_595_review_notice', 1 );

            }
        }
    }
}
add_action( 'upgrader_process_complete', 'gallery_from_files_595_upgrade_completed', 10, 2 );


function gallery_from_files_595_shortcode($args) {

    $shortcode = '';
    if (WP_DEBUG) {
        $shortcode = array();
        foreach ($args as $key => $value) {
            $shortcode[] = $key.'="'.$value.'"';
        }
        $shortcode = "\r\n". '<!-- [gallery-from-files '.implode(' ', $shortcode).'] -->' . "\r\n";
    }

	// Alapértelmezett értékek betöltése
	// Load default option values
	$options = gallery_from_files_595_get_options();
    $args = wp_parse_args($args, $options);

	// Elviekben lehetséges többszöri meghívás, ezért a jelző csak egyszer engedi betölteni a szkripteket.
	// In principle, multiple invitations are possible, so the token will only allow you to load scripts once.
	if (!defined('GALLERY_FROM_FILES_595')) {
		// A globális beállítások átadódnak a script-ek meghívásához
		// Global settings are passed to invite scripts
		gallery_from_files_595_styles_and_scripts_to_frontend();
	}

    // Osztály betöltése, ha kell
    // Load class if needed
    if (!class_exists('JGalleryFromFiles595')) {
        include_once( GALLERY_FROM_FILES_595_ROOT .DS. 'libs' .DS. 'class.php');
    }

    // Az alapértelmezett paraméterekkel történik az optiomalizálás
    // Init to default options
    $my_plugin = new JGalleryFromFiles595($args);

    $html = $shortcode . $my_plugin->prepareContent();
    
    return $html;
}
add_shortcode('gallery-from-files', 'gallery_from_files_595_shortcode');


function gallery_from_files_595_styles_and_scripts_to_frontend()
{
    global $pagenow;

    define('GALLERY_FROM_FILES_595', 1);

    // Csak a felhasználói oldalon töltődjenek be a szkriptek
    // Only load scripts on the user page
    if (in_array( $pagenow, array( 'post.php', 'page.php', 'index.php' ))) {

        wp_register_style( 'gallery-from-files', plugins_url( 'assets/css/gallery-from-files.css', __file__ ), array(), GALLERY_FROM_FILES_595_VERSION );
    	wp_enqueue_style( 'gallery-from-files' );
        
    	wp_register_script('gallery-from-files-js', plugins_url( 'assets/js/gallery-from-files.js', __file__ ), array('jquery'), GALLERY_FROM_FILES_595_VERSION, true);

        $options = gallery_from_files_595_get_options();
        if ((isset($options['fancy'])) and ($options['fancy'] == 1)) {
    
            wp_register_style( 'gallery-from-files-fancybox-css', plugins_url( 'assets/css/fancybox.min.css', __file__ ), array(), GALLERY_FROM_FILES_595_VERSION );
        	wp_enqueue_style(  'gallery-from-files-fancybox-css' );
            wp_register_script('gallery-from-files-fancybox', plugins_url( 'assets/js/fancybox/fancybox.min.js', __file__ ), array('jquery'), GALLERY_FROM_FILES_595_VERSION, true);
            wp_enqueue_script( 'gallery-from-files-fancybox');    
        }


		// Ajax hívás engedélyezése
		// Enable call ajax
		wp_localize_script('gallery-from-files-js', 'gallery_from_files_595_ajax_object', array( 'ajax_url' => admin_url( 'admin-ajax.php' ) ) );
		wp_enqueue_script('gallery-from-files-js');
    }
}

if ( is_admin() ){ 

    global $pagenow;

    if (in_array($pagenow, array('post.php', 'post-new.php'))) {
        if ( in_array( 'classic-editor/classic-editor.php', apply_filters( 'active_plugins', get_option( 'active_plugins' ) ) ) ) {
            include_once( GALLERY_FROM_FILES_595_ROOT .DIRECTORY_SEPARATOR. 'libs' .DIRECTORY_SEPARATOR. 'insert-button.php');
        }
    }

    include_once( GALLERY_FROM_FILES_595_ROOT .DS. 'libs' .DS. 'admin-functions.php');
    include_once( GALLERY_FROM_FILES_595_ROOT .DS. 'libs' .DS. 'gallery-from-files-setup.php' );
    $my_settings_page = new gallery_from_files_595_settings();
    
    function gallery_from_files_595_get_extra_meta_links($meta, $file, $data, $status) {

        if (plugin_basename(__FILE__) == $file) {
            $lang = get_bloginfo('language');
            if ($lang == 'hu') {
                $url = 'http://wpdemo.dovi42.hu/gallery-from-files';
            } else {
                $url = 'http://wpdemo.dovi42.hu/gallery-from-files-en';
            } 
            $meta[] = "<a href='".$url."' target='_blank' title='" . __('Detailed description and examples', 'gallery-from-files') . "'>".__('Detailed description and examples', 'gallery-from-files')."</a>";
        }
        return $meta;
    }
    add_filter("plugin_row_meta", 'gallery_from_files_595_get_extra_meta_links', 10, 4);
    

}

// Add settings link to media menu
function gallery_from_files_595_add_custom_link_into_appearnace_menu() {
    global $submenu;
    $permalink = 'options-general.php?page=gallery-from-files-setting-admin&gallery-from-files-tab=galleries';
    $submenu['upload.php'][] = array( __('Gallery from files', 'gallery-from-files'), 'manage_options', $permalink );
}
add_action('admin_menu', 'gallery_from_files_595_add_custom_link_into_appearnace_menu');


// Add settings link to plugins page 
function gallery_from_files_595_add_settings_link( $links ) {
    $settings_link = '<a href="options-general.php?page=gallery-from-files-setting-admin">' . __( 'Settings' ) . '</a>';
    array_unshift( $links, $settings_link );
  	return $links;
}
$plugin = plugin_basename( __file__ );
add_filter( "plugin_action_links_$plugin", 'gallery_from_files_595_add_settings_link' );

function gallery_from_files_595_styles_and_scripts_to_backend()
{
    global $pagenow;
    
    if (isset($_REQUEST['page'])) {
        $page = sanitize_text_field($_REQUEST['page']);
    } else {
        $page = '';
    }
    // Csak akkor töltődik be, amikor ennek a pluginnak a beállításai aktuálisak.
    if (($pagenow == 'options-general.php') and ($page == 'gallery-from-files-setting-admin')) {

        $tab = 'galleries';
        if (isset($_REQUEST['gallery-from-files-tab'])) { $tab = sanitize_text_field($_REQUEST['gallery-from-files-tab']); }
        if ($tab == 'galleries') {
            wp_enqueue_script('jquery-ui-sortable', '', array('jquery'));
        }

        wp_register_style( 'gallery-from-files-fancybox-css', plugins_url( 'assets/css/fancybox.min.css', __file__ ), array(), GALLERY_FROM_FILES_595_VERSION );
    	wp_enqueue_style(  'gallery-from-files-fancybox-css' );
        wp_register_script('gallery-from-files-fancybox', plugins_url( 'assets/js/fancybox/fancybox.min.js', __file__ ), array('jquery'), GALLERY_FROM_FILES_595_VERSION, true);
        wp_enqueue_script( 'gallery-from-files-fancybox');    


        wp_register_style( 'gallery-from-files-admin', plugins_url( 'assets/css/gallery-from-files-admin.css', __file__ ), array(), GALLERY_FROM_FILES_595_VERSION );
    	wp_enqueue_style( 'gallery-from-files-admin' );

    	wp_register_script('gallery-from-files-admin-js', plugins_url( 'assets/js/gallery-from-files-admin.js', __file__ ), array('jquery-ui-sortable'), GALLERY_FROM_FILES_595_VERSION);

        wp_register_style( 'image-crop', plugins_url( 'assets/css/jquery.Jcrop.css', __file__ ), array(), GALLERY_FROM_FILES_595_VERSION);
        wp_enqueue_style( 'image-crop' );
        wp_register_script('crop-js', plugins_url( 'assets/js/jquery.Jcrop.js', __file__ ), array('jquery'), GALLERY_FROM_FILES_595_VERSION);
    	wp_enqueue_script( 'crop-js');


		// Ajax hívás engedélyezése
		// Enable call ajax
		wp_localize_script('gallery-from-files-admin-js', 'gallery_from_files_595_ajax_object', array( 'ajax_url' => admin_url( 'admin-ajax.php' ) ) );
		$options = gallery_from_files_595_get_options();
		$ajax_vars = array(
				'size'       => $options['size'],
				'th_size'    => $options['th_size'],
				'th_folder'  => $options['th_folder'],
				'page_limit' => $options['page_limit'],
				'order'      => $options['order'],
				'title'      => $options['title'],
				'template'   => $options['template'],
                'url'        => home_url()
			);
		wp_localize_script('gallery-from-files-admin-js', 'gallery_from_files_ajax_vars', $ajax_vars);

        $gallery_lang = array(
                'NEW_FOLDER_LABEL'      => __('New folder name:', 'gallery-from-files'),
                'EDIT_TITLE_LABEL'      => __('Folder new name:', 'gallery-from-files'),
                'NEED_SELECTED_IMAGES'  => __('Is function need selected images!', 'gallery-from-files'),
                'ADD'                   => __('Add'),
                'RENAME'                => __('Rename', 'gallery-from-files'),
                'SELECTED_IMAGES_TITLE' => __('Selected images title:', 'gallery-from-files'),
                'EDIT_IMAGE_TITLE'      => __('Image name:', 'gallery-from-files'),
            );
        $gallery_wait = '<img class="gallery-from-files-wait-image" src="'.plugins_url( 'gallery-from-files/assets/images/wait.gif', GALLERY_FROM_FILES_595_ROOT).'" />';
        $gallery_wait_src = plugins_url( 'gallery-from-files/assets/images/wait.gif', GALLERY_FROM_FILES_595_ROOT);    
		wp_register_script('gallery-from-files-admin-js', '', array('jquery'), false, true);
		wp_localize_script('gallery-from-files-admin-js', 'gallery_lang', $gallery_lang);
		//wp_localize_script('gallery-from-files-admin-js', 'gallery_wait', $gallery_wait);
        wp_add_inline_script( 'gallery-from-files-admin-js', 'var gallery_wait = \''.$gallery_wait.'\';', 'before' );
		//wp_localize_script('gallery-from-files-admin-js', 'gallery_wait_src', $gallery_wait_src);
        wp_add_inline_script( 'gallery-from-files-admin-js', 'var gallery_wait_src = "'.$gallery_wait_src.'";', 'before' );
		wp_enqueue_script('gallery-from-files-admin-js');

        if ($tab == 'import') {
            wp_register_style( 'gallery-from-files-import', plugins_url( 'assets/css/gallery-from-files-import.css', __file__ ), array(), GALLERY_FROM_FILES_595_VERSION );
        	wp_enqueue_style( 'gallery-from-files-import' );

            $langs = array(
                'SET_FOLDER_TEXT' =>  __('Set the target folder!', 'gallery-from-files'),
                'REMOVE_IMAGES_FROM_MEDIA_LIBRARY' => __('Move images to trash from media library', 'gallery-from-files'),
            	'REMOVE_ALL_IMAGES_FROM_MEDIA_LIBRARY' => __('Move all images to trash from media library', 'gallery-from-files'),
            	'ABORT_IMPORT' => __('Stop import!', 'gallery-from-files'),
            	'ALL_GALLERY_IMPORTED' => __('All gallery imported', 'gallery-from-files'),
            	'IMPORT_ABORTED' => __('Gallery import aborted', 'gallery-from-files'),
            	'ABORT_MOVE_TRASH' => __('Abort move trash', 'gallery-from-files'),
            	'MOVE_COMPLETED' => __('Move completed', 'gallery-from-files'),
            	'MOVE_ABORTED' => __('Move aborted', 'gallery-from-files')
            );

        	wp_register_script('gallery-from-files-import-js', plugins_url( 'assets/js/gallery-from-files-import.js', __file__ ), array(), GALLERY_FROM_FILES_595_VERSION);
        	wp_localize_script('gallery-from-files-import-js', 'gallery_from_files_595_ajax_object', array( 'ajax_url' => admin_url( 'admin-ajax.php' ) ) );
        	wp_localize_script('gallery-from-files-import-js', 'GALLERY_LANGS', $langs );
            wp_enqueue_script('gallery-from-files-import-js');
        }
        
    }
}
add_action( 'admin_enqueue_scripts', 'gallery_from_files_595_styles_and_scripts_to_backend' );

include_once(GALLERY_FROM_FILES_595_ROOT .DS. 'libs' .DS. 'frontend-functions.php');    
