<?php

    if (!defined('DS')) {
        define( 'DS', DIRECTORY_SEPARATOR );
    }

function gallery_from_files_595_getUpFolder($path, $options) 
{

    $path = str_replace(GALLERY_FROM_FILES_595_WP_ROOT, '', $path);
    if (empty($path)) { return ''; }

    $path = explode(DS, $path);

    unset($path[count($path)-1]);
    $path = implode('|', $path);

    // $size = explode('x', $options['th_size']);
    $size = array(200, 200);
    
    $html = '<div class="gallery-from-files-folder-thumb">' . "\r\n";
    $html .= '<div class="gallery-from-files-jslink" ondblclick="gallery_from_files_595_js_setViewPath(\''.$path.'\');" style="width: '.$size[0].'px;">' . "\r\n";
    $html .= '<img src="'.plugins_url( 'gallery-from-files/assets/images/up.png', GALLERY_FROM_FILES_595_ROOT).'" style="width: '.$size[0].'px;" />' . "\r\n";
    $html .= '</div>' . "\r\n";
    $html .= '<div class="gallery-from-files-thumbnail-title">' . __('Directory up', 'gallery-from-files') . '</div>' . "\r\n";
    $html .= '</div>' . "\r\n";

    return '<li data-filename="[up]" class="sort-disabled">' . $html . '</li>';
}

function gallery_from_files_595_getFolder($item, $path, $options, $writeable = 1) {
   
    if ($item['title'] == $item['name']) {
        $title = '[' . $item['title'] . ']';
    } else {
        $title = $item['title'];
    }

    $title = str_replace('|', '<br />', $title);

    if (!class_exists ('JDovi42Files', false)) {
        include_once(dirname(__file__) .DS. 'jdovi42_files.php');
    }

    $info = new JDovi42Files($path .DS. $item['name']);
    $info->addTilt($options['th_folder']);   
    $info->allowExt = array('jpg', 'png', 'gif', 'tif');
    
    $folders = $info->getFolders();
    $files = $info->getFiles();

    $count = 0;
    if (!empty($folders)) { $count += count($folders); }
    if (!empty($files)) { $count += count($files); }


    // $size = explode('x', $options['th_size']);
    $size = array(200, 200);

    $path = str_replace(GALLERY_FROM_FILES_595_WP_ROOT, '', $path);
    if (!empty($path)) {
        $path = explode(DS, $path);
    } else {
        $path = array();
    }

    $path[] = $item['filename'];
    $path = implode('|', $path);

    if (substr($path, 0, 1) == DS) {
        $path = substr($path, 1);
    }

    $delete = ''; $edit = '';
    if ($writeable) {
        if ($count < 1) {
            $delete = '<div class="delete_folder_icon gallery-from-files-function-icon icon-left" onclick="gallery_from_files_595_js_deleteFolder(jQuery(this));" title="'.__('Delete item','gallery-from-files').'"><span class="dashicons dashicons-trash"></span></div>';
        }
        $edit = '<div class="edit_folder_icon gallery-from-files-function-icon icon-right" onclick="gallery_from_files_595_edit_folder_box(jQuery(this));" title="'.__('Edit item title','gallery-from-files').'"><span class="dashicons dashicons-admin-comments"></span></div>';
    }

    $thumbnail = '';
    if (isset($item['thumbnail'])) {
        $thumbnail = '<img class="gallery-from-files-folder-thumbnail" src="'.esc_url( home_url( '/' ) ) . str_replace('|', '/', $path) .'/'. $item['thumbnail'].'" style="max-width: '.($size[0]/2).'px;max-height: '.($size[1]/2).'px;" />' . "\r\n";
    }
    
    $bar = '';
    
    $html  = '<li id="folder_'.$item['name'].'" class="ui-state-default" data-filename="'.$item['filename'].'" data-path="'.$path.'">' . "\r\n";
    $html .= '  <div class="gallery-from-files-folder-thumb" style="max-width: '.$size[0].'px;">' . "\r\n";
    $html .= '      <div class="gallery-from-files-jslink" ondblclick="gallery_from_files_595_js_setViewPath(\''.$path.'\');" style="width: '.$size[0].'px;" title="'.__('Double click to open folder!','gallery-from-files').'">' . "\r\n";
    $html .= '          <img src="'.plugins_url( 'gallery-from-files/assets/images/empty-folder.png', GALLERY_FROM_FILES_595_ROOT).'" style="max-width: '.$size[0].'px;" />' . "\r\n";
    $html .= $thumbnail; 
    $html .= '      </div>' . "\r\n"; 
    $html .= '      <div class="gallery-from-files-item-functions-bar">' . "\r\n";
    $html .= $delete . $edit . "\r\n";
    $html .= '      </div>' . "\r\n";
    $html .= '      <div style="clear:both;"></div>' . "\r\n";
    $html .= '      <div class="gallery-from-files-thumbnail-title">' . $title . '</div>' . "\r\n";
    $html .= '  </div>' . "\r\n";
    $html .= '</li>' . "\r\n";
    return $html;
}


function gallery_from_files_595_getOrientation($size, $target) {
    $size = explode('x', $size);
    $landscape = true;
    if ((int)$size[1] > (int)$size[0]) {
        $landscape = false;
    }
    $target = explode('x', $target);
    $t_landscape = true;
    if ((int)$target[1] > (int)$target[0]) {
        $t_landscape = false;
    }
    
    if ($landscape != $t_landscape) {
        return $target[1].'x'.$target[0];
    }
    return $target[0].'x'.$target[1];
}


function gallery_from_files_595_getFiles($item, $path, $options, $index, $counter = 1, $writeable = 1) {

    if ($item['title'] == $item['filename']) {
        $title = '[' . $item['title'] . ']';
    } else {
        $title = str_replace('|', '<br />', $item['title']);
    }
    
    $size = explode('x', $options['th_size']);
    
    $path = str_replace(GALLERY_FROM_FILES_595_WP_ROOT, '', $path);
    
    $img = home_url() .DS. $path .DS. $item['filename'];
    $thumbnail = $img;
    $dimension = getimagesize(GALLERY_FROM_FILES_595_WP_ROOT . $path .DS. $item['filename']);
    if (isset($item['thumbnail'])) {
        $thumbnail = home_url() .DS. $path .DS. $item['thumbnail'];
        $th_dimension = getimagesize( str_replace(home_url(), GALLERY_FROM_FILES_595_WP_ROOT, $thumbnail) );
    } else {
        $th_dimension = gallery_from_files_595_getOrientation($dimension['0'] . 'x' . $dimension['1'], $options['th_size']);
        $th_dimension = explode('x', $th_dimension);
    } 
    
    $edit = ''; $crop = ''; $select = '';
    if ($writeable) {
        $edit   = '<div class="edit_icon gallery-from-files-function-icon icon-right" onclick="gallery_from_files_595_edit_image_box(jQuery(this));" title="'.__('Edit item title','gallery-from-files').'"><span class="dashicons dashicons-admin-comments"></span></div>';
        $crop   = '<div class="crop_icon gallery-from-files-function-icon icon-right" onclick="gallery_from_files_595_cropImage(jQuery(this));" title="'.__('Crop image','gallery-from-files').'"><span class="dashicons dashicons-image-crop"></span></div>';
        $select = '<div class="select_icon gallery-from-files-function-icon icon-left"><input type="checkbox" class="image-select" /></div>';
    }
    $shortcode = '<div class="shortcode-icon gallery-from-files-function-icon icon-left" onclick="gallery_from_files_595_copy_image_to_clipboard(jQuery(this));" style="display:inline-block;cursor:pointer;"><span class="dashicons dashicons-shortcode" title="'.__('Copy to clipboard', 'gallery-from-files').'"></span></div>';
    
    $html  = '<li id="img_'.$item['name'].$index.'" class="ui-state-default" data-filename="'.$item['filename'].'" data-w="'.$dimension[0].'" data-h="'.$dimension[1].'" data-counter="'.$counter.'">' . "\r\n";
    $html .= '  <div class="gallery-from-files-folder-thumb" style="width: '.$th_dimension[0].'px;">' . "\r\n";
    $html .= '      <div style="">' . "\r\n";
    $html .= '          <a class="image-link" data-fancybox="gallery" data-caption="'.$title.'" href="'.$img.'">' . "\r\n";    
    $html .= '              <img class="thumbnail-link" src="'.$thumbnail.'" style="width: '.$th_dimension[0].'px;height:'.$th_dimension[1].'px;" />' . "\r\n";
    $html .= '          </a>' . "\r\n";
    $html .= '      </div>';
    $html .= '      <div class="gallery-from-files-item-functions-bar">' . "\r\n";
    $html .= $select . $shortcode; 
    $html .= '&nbsp;<div class="size-info">'.$dimension['0'] . 'x' . $dimension['1'].'</div>';                
    $html .= $edit . $crop . "\r\n";
    $html .= '      </div>' . "\r\n";
    $html .= '      <div style="clear:both;"></div>' . "\r\n";
    $html .= '      <div class="gallery-from-files-thumbnail-title">' . $title . '</div>' . "\r\n";
    $html .= '  </div>' . "\r\n";
    $html .= '</li>' . "\r\n";
    return $html;
}



function gallery_from_files_595_js_sort_reorder() {

    if (!isset($_REQUEST['path'])) {
        $data = array(
            'status' => 0,
            'message' => __('Path not set!', 'gallery-from-files')
        );
        echo json_encode($data);          
        wp_die();
    }
    
    $path  = sanitize_text_field($_REQUEST['path']);

    $order = sanitize_text_field($_REQUEST['order']);
    $order = json_decode(stripslashes($order));
    $order = implode("\r\n", $order);
    $ok = file_put_contents($path .DS. 'filesort.txt', $order); 
    
    $message = '';
    if ($ok !== false) {
        $status = 1;
        chmod($path .DS. 'filesort.txt', 0644);
    } else {
        $status = 0;
        $message = __('Error in file creation!', 'gallery-from-files');
    }

    $data = array(
        'status'   => $status,
        'message'  => $message
    );
    echo json_encode($data);          
    wp_die();
}
add_action( 'wp_ajax_nopriv_gallery_from_files_595_js_sort_reorder', 'gallery_from_files_595_js_sort_reorder' );
add_action( 'wp_ajax_gallery_from_files_595_js_sort_reorder', 'gallery_from_files_595_js_sort_reorder' );

function gallery_from_files_595_js_new_folder()
{
    $data = array();
    foreach ($_REQUEST as $key => $value) {
        $data[sanitize_text_field($key)] = sanitize_text_field($value);
    }

    if (!class_exists ('JDovi42Files', false)) {
        include_once(dirname(__file__) .DS. 'jdovi42_files.php');
    }
    $folder = new JDovi42Files($data['path']);
    $title = explode('|', $data['title']);
    $alias = $folder->getAlias($title[0]);
    $alias = $folder->getEmptyName($alias);
    
    $item = $folder->newFolder($alias, $data['title']);
    
    if ($item) {
        $options = gallery_from_files_595_get_options();
        $path = str_replace(DS.DS, DS, $data['path']);
        $path = str_replace(GALLERY_FROM_FILES_595_WP_ROOT, '', $path);
        $html = gallery_from_files_595_getFolder($item, $path, $options); 

        $data = array(
            'status' => 1,
            'html'   => $html
        );
    } else {
        $data = array(
            'status'  => 0,
            'message' => __('Folder creation error.', 'gallery-from-files') . '('.str_replace(GALLERY_FROM_FILES_595_WP_ROOT, '', $data['path']).$alias.')'
        );
    }
    echo json_encode($data);          
    wp_die();
}
add_action( 'wp_ajax_nopriv_gallery_from_files_595_js_new_folder', 'gallery_from_files_595_js_new_folder' );
add_action( 'wp_ajax_gallery_from_files_595_js_new_folder', 'gallery_from_files_595_js_new_folder' );

function gallery_from_files_595_js_delete_folder()
{
    $data = array();
    foreach ($_REQUEST as $key => $value) {
        $data[sanitize_text_field($key)] = sanitize_text_field($value);
    }

    if (!class_exists ('JDovi42Files', false)) {
        include_once(dirname(__file__) .DS. 'jdovi42_files.php');
    }
    $folder = new JDovi42Files($data['path']);

    if ($folder->deleteFolder($data['filename'])) {
        $data = array(
            'status' => 1,
            'id'     => $data['id']
        );
    } else {
        $data = array(
            'status'  => 0,
            'id'     => $data['id'],
            'message' => __('Folder delete error.', 'gallery-from-files') . '('.str_replace(GALLERY_FROM_FILES_595_WP_ROOT, '', $data['path']).$alias.')'
        );
    }
    echo json_encode($data);          
    wp_die();
}
add_action( 'wp_ajax_nopriv_gallery_from_files_595_js_delete_folder', 'gallery_from_files_595_js_delete_folder' );
add_action( 'wp_ajax_gallery_from_files_595_js_delete_folder', 'gallery_from_files_595_js_delete_folder' );

function gallery_from_files_595_edit_description()
{
    $data = array();
    foreach ($_REQUEST as $key => $value) {
        $data[sanitize_text_field($key)] = sanitize_text_field($value);
    }

    $data['title'] = stripslashes($data['title']);
    $options = gallery_from_files_595_get_options();

    if (!class_exists ('JDovi42Files', false)) {
        include_once(dirname(__file__) .DS. 'jdovi42_files.php');
    }
    $folder = new JDovi42Files($data['path']);
    if ($options['rename'] != 0) {

        $title = explode('|', $data['title']);
        
        $alias = $folder->getAlias($title[0]);
        $info = pathinfo($data['path'].DS.$data['filename'], PATHINFO_FILENAME);
        
        if ($info == $alias) {
            $folder->updateDescription($data['filename'], stripslashes($data['title']));
            $data = array(
                'status'   => 1,
                'id'       => $data['id'],
                'filename' => $data['filename'],
                'title'    => $data['title']
            );
            echo json_encode($data);          
            wp_die();
        }
        
        $filename = $folder->rename($data['filename'], $title[0]);
        // Thumbnail rename
        if (file_exists($data['path'] .DS. $options['th_folder'] .DS. $data['filename'])) {
            rename($data['path'] .DS. $options['th_folder'] .DS. $data['filename'], $data['path'] .DS. $options['th_folder'] .DS. $filename);
        }
        if (isset($options['webp']) and ($options['webp'] == 1)) {
            $orig_name = pathinfo($data['path'] .DS. $data['filename'], PATHINFO_FILENAME);   
            $new_name  = pathinfo($data['path'] .DS. $filename, PATHINFO_FILENAME);
            if (file_exists($data['path'] .DS. $orig_name.'.webp')) {
                rename($data['path'] .DS. $orig_name.'.webp', $data['path'] .DS. $new_name.'.webp');
            }
            if (file_exists($data['path'] .DS. $options['th_folder'] .DS. $orig_name.'.webp')) {
                rename($data['path'] .DS. $options['th_folder'] .DS. $orig_name.'.webp', $data['path'] .DS. $options['th_folder'] .DS. $new_name.'.webp');
            }
        }
    } else {
        $filename = $data['filename'];
        $folder->updateDescription($filename, stripslashes($data['title']));
    }



    $data = array(
        'status'   => 1,
        'id'       => $data['id'],
        'filename' => $filename,
        'title'    => $data['title']
    );
    echo json_encode($data);          
    wp_die();
    
}
add_action( 'wp_ajax_nopriv_gallery_from_files_595_edit_description', 'gallery_from_files_595_edit_description' );
add_action( 'wp_ajax_gallery_from_files_595_edit_description', 'gallery_from_files_595_edit_description' );

function gallery_from_files_595_rotate_image()
{
    $data = array();
    foreach ($_REQUEST as $key => $value) {
        $data[sanitize_text_field($key)] = sanitize_text_field($value);
    }
    $options = gallery_from_files_595_get_options();

    if (!class_exists ('JDovi42Image', false)) {
        include_once( dirname(__file__) .DS. 'jdovi42_image.php');
    }

    $data['path'] = str_replace(DS.DS, DS, $data['path']);

    $img = new JDovi42Image($data['path'] .DS. $data['filename']);
    $img->jpeg_compress = $options['compress'];
    $img->rotateImage($data['mode']);
    
    if (isset($options['webp']) and ($options['webp'] == 1)) {
        $img->createWebP();
    }

    $image = home_url() . str_replace(GALLERY_FROM_FILES_595_WP_ROOT, '/', $data['path']) .DS. $data['filename'];
    $thumbnail = $image;
    
    if (file_exists($data['path'] .DS. $options['th_folder'] .DS. $data['filename'])) {
        $img = new JDovi42Image($data['path'] .DS. $options['th_folder'] .DS. $data['filename']);
        $img->jpeg_compress = $options['compress'];
        $img->rotateImage($data['mode']);
        if (isset($options['webp']) and ($options['webp'] == 1)) {
            $img->createWebP();
        }
        $thumbnail = home_url() . str_replace(GALLERY_FROM_FILES_595_WP_ROOT, '/', $data['path']) .DS. $options['th_folder'] .DS. $data['filename'];
    }
    
    $data = array(
        'status'    => 1,
        'id'        => $data['id'],
        'image'     => str_replace(DS, '/', $image),
        'thumbnail' => str_replace(DS, '/', $thumbnail),
        'mode'      => $data['mode']
    );
    echo json_encode($data);          
    wp_die();
    
}
add_action( 'wp_ajax_nopriv_gallery_from_files_595_rotate_image', 'gallery_from_files_595_rotate_image' );
add_action( 'wp_ajax_gallery_from_files_595_rotate_image', 'gallery_from_files_595_rotate_image' );


function gallery_from_files_595_resize_image()
{
    $data = array();
    foreach ($_REQUEST as $key => $value) {
        $data[sanitize_text_field($key)] = sanitize_text_field($value);
    }
    $options = gallery_from_files_595_get_options();

    if (!class_exists ('JDovi42Image', false)) {
        include_once( dirname(__file__) .DS. 'jdovi42_image.php');
    }

    $data['path'] = str_replace(DS.DS, DS, $data['path']);

    $img = new JDovi42Image($data['path'] .DS. $data['filename']);
    $img->jpeg_compress = $options['compress'];
    $img->resizeImage($options['size']);
    if (isset($options['webp']) and ($options['webp'] == 1)) {
        $img->createWebP();
    }

    $img->createThumb($options['th_size'], $options['th_folder']);
    $image = home_url() . str_replace(GALLERY_FROM_FILES_595_WP_ROOT, '/', $data['path']) .DS. $data['filename'];

    if (isset($options['webp']) and ($options['webp'] == 1)) {
        $thumb = new JDovi42Image($data['path'] .DS. $options['th_folder'] .DS. $data['filename']);
        $thumb->createWebP();
    }

    $thumbnail = $image;
    if (file_exists($data['path'] .DS. $options['th_folder'] .DS. $data['filename'])) {
        $thumbnail = home_url() . str_replace(GALLERY_FROM_FILES_595_WP_ROOT, '/', $data['path']) .DS. $options['th_folder'] .DS. $data['filename'];
    }
    
    $size = $img->getSize();
    
    $data = array(
        'status'    => 1,
        'id'        => $data['id'],
        'image'     => str_replace(DS, '/', $image),
        'thumbnail' => str_replace(DS, '/', $thumbnail),
        'size'      => $size->width . 'x' . $size->height    
    );
    echo json_encode($data);          
    wp_die();
    
}
add_action( 'wp_ajax_nopriv_gallery_from_files_595_resize_image', 'gallery_from_files_595_resize_image' );
add_action( 'wp_ajax_gallery_from_files_595_resize_image', 'gallery_from_files_595_resize_image' );

function gallery_from_files_595_generate_thumbnail()
{
    $data = array();
    foreach ($_REQUEST as $key => $value) {
        $data[sanitize_text_field($key)] = sanitize_text_field($value);
    }
    $options = gallery_from_files_595_get_options();

    $data['path'] = str_replace(DS.DS, DS, $data['path']);

    if (!class_exists ('JDovi42Image', false)) {
        include_once( dirname(__file__) .DS. 'jdovi42_image.php');
    }
    $image = home_url() . str_replace(GALLERY_FROM_FILES_595_WP_ROOT, '/', $data['path']) .DS. $data['filename'];
    $img = new JDovi42Image($data['path'] .DS. $data['filename']);
    $img->jpeg_compress = $options['compress'];
    
    $img->createThumb($options['th_size'], $options['th_folder']);
    $thumbnail = home_url() . str_replace(GALLERY_FROM_FILES_595_WP_ROOT, '/', $data['path']) .DS. $options['th_folder'] .DS. $data['filename'];

    if (isset($options['webp']) and ($options['webp'] == 1)) {
        $img = new JDovi42Image($data['path'] .DS. $options['th_folder'] .DS. $data['filename']);
        $img->createWebP();
    }

    
    $data = array(
        'status'    => 1,
        'id'        => $data['id'],
        'image'     => str_replace(DS, '/', $image),
        'thumbnail' => str_replace(DS, '/', $thumbnail)
    );
    echo json_encode($data);          
    wp_die();
    
}
add_action( 'wp_ajax_nopriv_gallery_from_files_595_generate_thumbnail', 'gallery_from_files_595_generate_thumbnail' );
add_action( 'wp_ajax_gallery_from_files_595_generate_thumbnail', 'gallery_from_files_595_generate_thumbnail' );

function gallery_from_files_595_generate_watermark()
{
    $data = array();
    foreach ($_REQUEST as $key => $value) {
        $data[sanitize_text_field($key)] = sanitize_text_field($value);
    }
    $options = gallery_from_files_595_get_options();

    if ($options['watermark'] == '') {
        $data = array(
            'status'    => 0,
            'id'        => $data['id'],
            'message'   => __('Watermark image not set.', 'gallery-from-files')
        );
        echo json_encode($data);          
        wp_die();
    }
    $upload = wp_get_upload_dir();
    $watermark_image = $upload['basedir'] .DS. $options['watermark'];
    if (!file_exists($watermark_image)) {
        $data = array(
            'status'    => 0,
            'id'        => $data['id'],
            'message'   => __('Watermark image not found.', 'gallery-from-files')
        );
        echo json_encode($data);          
        wp_die();
    }

    if (!class_exists ('JDovi42Image', false)) {
        include_once( dirname(__file__) .DS. 'jdovi42_image.php');
    }
    $image = home_url() . str_replace(GALLERY_FROM_FILES_595_WP_ROOT, '/', $data['path']) .DS. $data['filename'];
    $img = new JDovi42Image($data['path'] .DS. $data['filename']);
    $img->jpeg_compress = $options['compress'];
    
    $img->watermark['walign'] = 'right';
    $img->watermark['halign'] = 'bottom';
    $img->createWatermark($watermark_image);
    
    if (isset($options['webp']) and ($options['webp'] == 1)) {
        $img->createWebP();
    }
    
   
    $thumbnail = $image;
    if (file_exists($data['path'] .DS. $options['th_folder'] .DS. $data['filename'])) {
        $thumbnail = home_url() . str_replace(GALLERY_FROM_FILES_595_WP_ROOT, '/', $data['path']) .DS. $options['th_folder'] .DS. $data['filename'];
    }
    
    $data = array(
        'status'    => 1,
        'id'        => $data['id'],
        'image'     => $image,
        'thumbnail' => $thumbnail
    );
    echo json_encode($data);          
    wp_die();
    
}
add_action( 'wp_ajax_nopriv_gallery_from_files_595_generate_watermark', 'gallery_from_files_595_generate_watermark' );
add_action( 'wp_ajax_gallery_from_files_595_generate_watermark', 'gallery_from_files_595_generate_watermark' );

function gallery_from_files_595_delete_image()
{

    $data = array();
    foreach ($_REQUEST as $key => $value) {
        $data[sanitize_text_field($key)] = sanitize_text_field($value);
    }
    $options = gallery_from_files_595_get_options();

    if (!class_exists ('JDovi42Files', false)) {
        include_once(dirname(__file__) .DS. 'jdovi42_files.php');
    }
    
    $data['path'] = str_replace(DS.DS, DS, $data['path']);
    
    $path = new JDovi42Files($data['path']);
    $path->deleteFile($data['filename']);

    $webp = pathinfo($data['path'].DS.$data['filename'], PATHINFO_FILENAME) . '.webp';
    if (file_exists($data['path'].DS.$webp)) { unlink($data['path'].DS.$webp); }

    if (file_exists($data['path'] .DS. $options['th_folder'] .DS. $data['filename'])) {
        unlink($data['path'] .DS. $options['th_folder'] .DS. $data['filename']);
        $webp = pathinfo($data['path'].DS.$options['th_folder'].DS.$data['filename'], PATHINFO_FILENAME) . '.webp';
        if (file_exists($data['path'].DS.$options['th_folder'].DS.$webp)) { unlink($data['path'].DS.$options['th_folder'].DS.$webp); }
    }
     
    $data = array(
        'status'    => 1,
        'id'        => $data['id']
    );
    echo json_encode($data);          
    wp_die();
}
add_action( 'wp_ajax_nopriv_gallery_from_files_595_delete_image', 'gallery_from_files_595_delete_image' );
add_action( 'wp_ajax_gallery_from_files_595_delete_image', 'gallery_from_files_595_delete_image' );


function gallery_from_files_595_fileupload()
{
    $data = array();
    foreach ($_REQUEST as $key => $value) {
        $data[sanitize_text_field($key)] = sanitize_text_field($value);
    }

    $name     = $data['filesName'];
    $files    = $_FILES[$name];
    $options  = gallery_from_files_595_get_options();

    // Allowed extensions
    if (!isset($data['allowExt'])) {
        $allowExt = array('jpg', 'png', 'gif');
    } else {
        $allowExt = explode(',', $data['allowExt']);
    }
    // Disable extensions
    $allowExt = array_diff($allowExt, array('php', 'js'));

    // Allowed size
    $maxSize  = $data['maxSize']; // *1000 
    if ($maxSize == null) { $maxSize = 0; }

    $target_dir = $data['uploadDir'];
    if (!class_exists ('JDovi42Files', false)) {
        include_once(dirname(__file__) .DS. 'jdovi42_files.php');
    }
    $target = new JDovi42Files($target_dir);
    $target->checkFolder($target_dir);
    
    for ($i = 0; $i <= count($files['name'])-1; $i++) {
        
        $error = array();
        
        $path_parts = pathinfo($files['name'][$i]);
        $ext  = strtolower(trim($path_parts['extension']));
        $name = $path_parts['filename'];
        $size = $files['size'][$i];

        // Ha nincs megadva fájl.
        if (empty($name)) {
            $error[] = __('File not set.', 'gallery-from-files');
        } 
        
        // Ha a fájl típusa nem megfelelő
        if (($allowExt != null) and (!in_array($ext, $allowExt))) {
            $error[] = __('File type not allowed.', 'gallery-from-files');
        }
        
        // Ha a fájl mérete nem megfelelő
        if (($maxSize != 0) and ($size > ($maxSize * 1000))) {
            $error[] = __('Files size too big.', 'gallery-from-files');
        }

        // Szerveroldali hibák
        switch($files['error'][$i])
		{
			case '1':
				$error[] = __('The uploaded file exceeds the upload_max_filesize directive in php.ini', 'gallery-from-files');
				break;
			case '2':
				$error[] = __('The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form', 'gallery-from-files');
				break;
			case '3':
				$error[] = __('The uploaded file was only partially uploaded', 'gallery-from-files');
				break;
			case '4':
				$error[] = __('No file was uploaded.', 'gallery-from-files');
				break;
			case '6':
				$error[] = __('Missing a temporary folder', 'gallery-from-files');
				break;
			case '7':
				$error[] = __('Failed to write file to disk', 'gallery-from-files');
				break;
			case '8':
				$error[] = __('File upload stopped by extension', 'gallery-from-files');
				break;
			case '999':
			default:

		}

        if (empty($target_dir)) {
            $error[] = __('Not set target folder.', 'gallery-from-files');
        }

        if (empty($error)) {
            
            $name = $target->getAlias($name);
            $name = $target->getEmptyName($name . '.' . $ext);

            $inFile  = $files['tmp_name'][$i];
            $outFile = $target_dir .DS. $name;

			if (!move_uploaded_file($inFile, $outFile)) {
				$error[] = "Nem sikerült a fájlok átmozgatása!" . "(" . $outFile . ')';
            } else {
                chmod($outFile, 0664);
            }
			@unlink($inFile);	

            include_once( dirname(__file__) .DS. 'jdovi42_image.php');

            $img = new JDovi42Image($outFile);
            $img->jpeg_compress = $options['compress'];
            
            // Resize image
            if (isset($data['size'])) {
                $img->resizeImage($data['size']);
            }            
            
            // Create Thumbnail
            if ((isset($data['th_size'])) and (isset($data['th_folder']))) {
                $img->createThumb($data['th_size'], $data['th_folder']);
                if (isset($options['webp']) and ($options['webp'] == 1)) {
                    $thumb = new JDovi42Image( pathinfo($outFile,  PATHINFO_DIRNAME) .DS. $data['th_folder'] .DS.  pathinfo($outFile,  PATHINFO_FILENAME));
                    $thumb->createWebP();
                }
            }            

            // Insert watermark
            if ((isset($data['watermark'])) and ($data['watermark'] != '')) {
                $img->watermark['walign'] = 'right';
                $img->watermark['halign'] = 'bottom';
                $img->createWatermark($data['watermark']);
            }

            if (isset($options['webp']) and ($options['webp'] == 1)) {
                $img->createWebP();
            }
            
        }
    }

    if (empty($error)) {
        // $error = 'A fájl sikeresen feltöltve.';
        $data = array(
            'status' => 1,
            'message' => 'Sikeres a fájl(ok) másolása.'
        );
        echo json_encode($data);          
    } else {
        $result[] = '<div>'.$name. ' : ' . '<span style="color: red;">Hiba</span> : ' . implode(', ', $error) . '</div>';
        $data = array(
            'status' => 0,
            'message' => implode('', $result)
        );
        echo json_encode($data);          
    }
    wp_die();
}
add_action( 'wp_ajax_nopriv_gallery_from_files_595_fileupload', 'gallery_from_files_595_fileupload' );
add_action( 'wp_ajax_gallery_from_files_595_fileupload', 'gallery_from_files_595_fileupload' );

function gallery_from_files_595_save_crop_impage()
{

    $id       = sanitize_text_field($_REQUEST['id']);
    $path     = sanitize_text_field($_REQUEST['path']);
    $path = str_replace(DS.DS, DS, $path);
    $filename = sanitize_text_field($_REQUEST['filename']);
    $cropdata = array_map( 'esc_attr', $_REQUEST['data'] );
    $options  = gallery_from_files_595_get_options(); 

    if (!class_exists ('JDovi42Image', false)) {
        include_once( dirname(__file__) .DS. 'jdovi42_image.php');
    }

    $img = new JDovi42Image($path .DS. $filename);
    $img->jpeg_compress = $options['compress'];
    $size = $img->getOrientation($cropdata['width'].'x'.$cropdata['height'], $options['size']);
    
    $img->cropImage($cropdata, $size);
    if (isset($options['webp']) and ($options['webp'] == 1)) {
        $img->createWebP();
    }

    $img->createThumb($options['th_size'], $options['th_folder']);
    if (isset($options['webp']) and ($options['webp'] == 1)) {
        $thumb = new JDovi42Image( $path .DS. $options['th_folder'] .DS. $filename );
        $thumb->createWebP();
    }
    
    $thumbnail = home_url() . str_replace(GALLERY_FROM_FILES_595_WP_ROOT, '/', $path) .DS. $options['th_folder'] .DS. $filename;

    $data = array(
        'status'    => 1,
        'id'        => $id,
        'thumbnail' => str_replace(DS, '/', $thumbnail),
        'size'      => $size    
    );
    echo json_encode($data);          
    wp_die();
}
add_action( 'wp_ajax_nopriv_gallery_from_files_595_save_crop_impage', 'gallery_from_files_595_save_crop_impage' );
add_action( 'wp_ajax_gallery_from_files_595_save_crop_impage', 'gallery_from_files_595_save_crop_impage' );


function gallery_from_files_595_group_filename() {
    $results = array();

    $options = gallery_from_files_595_get_options();
    
    $ids      = $_REQUEST['group'];
    $title    = sanitize_text_field($_REQUEST['title']);
    $path     = sanitize_text_field($_REQUEST['path']);
    $files    = $_REQUEST['files'];

    $path = str_replace(DS.DS, DS, $path);

    if (substr($path, -1) != DS) {
        $path .= DS;
    }
    
    if (!class_exists ('JDovi42Files', false)) {
        include_once(dirname(__file__) .DS. 'jdovi42_files.php');
    }

    $source = new JDovi42Files($path);

    if ($options['rename'] != 0) {

        $temp_title = explode('|', $title);

        $alias = $source->getAlias($temp_title[0]);
        $sizes = array($options['th_folder']);
    
        for ($i = 0; $i <= count($ids)-1; $i++) {
            
            $counter = $i + 1;
            if ($counter < 10) { $counter = '0'.$counter; }
            
            $alias_index = pathinfo($path .DS. $alias, PATHINFO_FILENAME) . '-'.$counter;
            $alias_index = $source->getAlias($alias_index);    	
    
            $thumbs = array();
    
            $alias_index = $source->rename($files[$i], $alias_index);
            $source->deleteDescription($files[$i]);
            $source->updateDescription($alias_index, $title);
            if ($options['webp'] == 1) {
                $fname = pathinfo($path .DS. $files[$i], PATHINFO_FILENAME);
                if (file_exists($path .DS. $fname.'.webp')) {
                    $aname = pathinfo($path .DS. $alias_index, PATHINFO_FILENAME) . '.webp';
                    rename($path .DS. $fname.'.webp', $path  .DS. $aname);
                }
            }
    
            foreach ($sizes as $size) {
                if (file_exists($path .DS. $size .DS. $files[$i])) {
                    rename($path .DS. $size .DS. $files[$i], $path .DS. $size .DS. $alias_index);
                    $ext = pathinfo($path .DS. $size .DS. $alias_index, PATHINFO_EXTENSION);
                    if ($options['webp'] == 1) {
                        $fname = pathinfo($path .DS. $size .DS. $files[$i], PATHINFO_FILENAME);
                        if (file_exists($path .DS. $size .DS. $fname.'.webp')) {
                            $aname = pathinfo($path .DS. $size .DS. $alias_index, PATHINFO_FILENAME) . '.webp';
                            rename($path .DS. $size .DS. $fname.'.webp', $path .DS. $size .DS. $aname);
                        }
                    }
                    $thumbs[] = array(
                            'cl'  => $size,
                            'url' => home_url() . str_replace(GALLERY_FROM_FILES_595_WP_ROOT, '/', $path) . $size .DS. $alias_index                
                        );                
                }
            }
            
            $results[] = array(
                    'id' => $ids[$i],
                    'filename' => $alias_index,
                    'alias'    => pathinfo($alias_index, PATHINFO_FILENAME),
                    'url'      => home_url() . str_replace(GALLERY_FROM_FILES_595_WP_ROOT, '/', $path) . $alias_index,
                    'thumbs'   => $thumbs
                );
    
            
        }
    } else {
        for ($i = 0; $i <= count($ids)-1; $i++) {

            $source->updateDescription($files[$i], stripslashes($title));

            $sizes = array($options['th_folder']);
            $thumbs = array();
            foreach ($sizes as $size) {
                $thumbs[] = array(
                        'cl'  => $size,
                        'url' => home_url() . str_replace(GALLERY_FROM_FILES_595_WP_ROOT, '/', $path) . $size .DS. $files[$i]                
                    );                
            }

            $results[] = array(
                    'id' => $ids[$i],
                    'filename' => $files[$i],
                    'alias'    => pathinfo($files[$i], PATHINFO_FILENAME),
                    'url'      => home_url() . str_replace(GALLERY_FROM_FILES_595_WP_ROOT, '/', $path) . $files[$i],
                    'thumbs'   => $thumbs
                );
        }
    }
    $data = array(
        'status'   => 1,
        'title'    => $title, 
        'group'    => $results
    );
    echo json_encode($data);          
    wp_die();
    
}
add_action( 'wp_ajax_nopriv_gallery_from_files_595_group_filename', 'gallery_from_files_595_group_filename' );
add_action( 'wp_ajax_gallery_from_files_595_group_filename', 'gallery_from_files_595_group_filename' );

