<?php

function gallery_from_files_595_get_images_page() {
    $data = $_REQUEST;
    
    $options = $data['variables'];
    $options = array_map( 'esc_attr', $options );
    $id      = sanitize_text_field( $_REQUEST['id'] );
    $type    = sanitize_text_field( $_REQUEST['type'] );    

    if (!class_exists ('JGalleryFromFiles595', false)) {
        include_once(dirname(__file__) .DS. 'class.php');
    }
    $my_plugin = new JGalleryFromFiles595($options);
    
    if ($type == 'images') {
        $my_plugin->image_html = $my_plugin->getTemplate('images.html', false);
        $source = $my_plugin->getImages();
    } else {
        $my_plugin->image_html = $my_plugin->getTemplate('folders.html', false);
        $source = $my_plugin->getFolders();
    }
    $count = count($source); 
    $source = array_slice($source, (($data['page']-1)*$options['page_limit']), $options['page_limit']);

    if ($type == 'images') {
        $source = $my_plugin->checkImages($source);
        $html = $my_plugin->renderImages($source);
    } else {
        $html = $my_plugin->renderFolders($source);
    }
    
    $result = array(
        'status' => 1,
        'html'   => $html,
        'id'     => $id
    );
    echo json_encode($result);
    wp_die();

}
add_action( 'wp_ajax_nopriv_gallery_from_files_595_get_images_page', 'gallery_from_files_595_get_images_page' );
add_action( 'wp_ajax_gallery_from_files_595_get_images_page', 'gallery_from_files_595_get_images_page' );

function gallery_from_files_595_import_from_content() {

    $id = '';
    if (isset($_REQUEST['id'])) {
        $id   = sanitize_text_field( $_REQUEST['id'] );
    }
    $post = '';
    if (isset($_REQUEST['post'])) {
        $post = sanitize_text_field( $_REQUEST['post'] );    
    }
    $target = '';
    if (isset($_REQUEST['target'])) {
        $target = sanitize_text_field( $_REQUEST['target'] );    
    }

    $counter = 0;

    if (empty($post)) {
        $result = array(
            'status'  => 0,
            'id'      => $id,
            'message' => __('Not set post ID', 'gallery-from-files')
        );
        
    } else {

        if (!class_exists ('JDovi42Files', false)) {
           include_once(dirname(__FILE__) .DS. 'jdovi42_files.php');
        }

        $post = get_post($post);
        $slug = $post->post_name;

        $regex = "/\[gallery \s*.*?]/i";
        preg_match_all( $regex, $post->post_content, $matches, PREG_SET_ORDER);

        $folder = new JDovi42Files(ABSPATH . '/'.$target.'/');

        for ($i = 0; $i <= count($matches)-1; $i++) {
            preg_match_all('/(ids)="([^"]*)"/i',$matches[$i][0], $imgs);
            $images = explode(',', $imgs[2][0]);
            
            $to_path = ABSPATH . $target.'/'.$slug.'/';
            $alias = $slug;
            if (count($matches) > 1) {
                $to_path = ABSPATH . $target.'/'.$slug.'-'.($i+1).'/';
                $alias = $slug.'-'.($i+1);
            }

            $folder->checkFolder($to_path);
            $folder->updateDescription($alias, $post->post_title);

            $images_folder = new JDovi42Files($to_path);

            $sort = array();
            foreach ($images as $image) {
                
                $temp = wp_get_attachment_image_src( $image, 'full', false );
                $from = ABSPATH . str_replace(home_url('/'), '', $temp[0]);
                $file_name = pathinfo($from, PATHINFO_FILENAME);
                $file_name = $images_folder->getAlias($file_name);
                $file_ext = pathinfo($from, PATHINFO_EXTENSION);
                $file_ext = mb_strtolower($file_ext);
                $file = $file_name.'.'.$file_ext;
                
                $to = $to_path . $file;
                
                $title = get_the_excerpt($image);
                copy($from, $to);
                $images_folder->updateDescription($file, $title);
                
                $sort[] = $file; 
                $counter++;
            }
            file_put_contents($to_path.'/filesort.txt', implode("\r\n", $sort));
            
            $to_folder = str_replace(ABSPATH, '', substr($to_path, 0, -1));
            $post->post_content = str_replace($matches[$i][0], '[gallery-from-files folder="'.$to_folder.'" template="images"]', $post->post_content);
            
            $my_post = array(
                'ID' => $post->ID,
                'post_content' => $post->post_content
            );
            wp_update_post( $my_post );
            
        }

        $result = array(
            'status'  => 1,
            'id'      => $id,
            'message' => sprintf( __('%s images copied', 'gallery-from-files'), $counter),
            'trash'   => MEDIA_TRASH
        );
    }   

    echo json_encode($result);
    wp_die();
}
add_action( 'wp_ajax_gallery_from_files_595_import_from_content', 'gallery_from_files_595_import_from_content' );


function gallery_from_files_595_remove_images_from_library() {

    $id = '';
    if (isset($_REQUEST['id'])) {
        $id   = sanitize_text_field( $_REQUEST['id'] );
    }
    $images = '';
    if (isset($_REQUEST['images'])) {
        $images = sanitize_text_field( $_REQUEST['images'] );    
    }

    $counter = 0;

    if ((!defined('MEDIA_TRASH')) or (!MEDIA_TRASH)) {
        wp_die();    
    }

    if (empty($images)) {
        $result = array(
            'status'  => 0,
            'id'      => $id,
            'message' => __('Not set images list', 'gallery-from-files')
        );
        
    } else {
        
        $images = explode(',', $images);
        foreach ($images as $image) {
            wp_delete_attachment( $image, false );
            $counter++;            
        }

        $result = array(
            'status'  => 1,
            'id'      => $id,
            'message' => sprintf( __('%s images moved to trash', 'gallery-from-files'), $counter)
        );
    }   

    echo json_encode($result);
    wp_die();
}
add_action( 'wp_ajax_gallery_from_files_595_remove_images_from_library', 'gallery_from_files_595_remove_images_from_library' );
