<?php

    if (!defined('DS')) {
        define( 'DS', DIRECTORY_SEPARATOR );
    }

class JGalleryFromFiles extends stdClass
{
    private $options = array();
    private $path = '';
    private $folders = array();
    private $files = array();
    private $is_writeable = false;
    
    public function __construct($options)
	{
        $this->options = $options;	   
        $this->path = GALLERY_FROM_FILES_595_WP_ROOT;
        
        if (isset($_REQUEST['gallery-from-files-path'])) {
            $this->path .= sanitize_text_field($_REQUEST['gallery-from-files-path']); 
        } else  {
            if (isset($_COOKIE['gallery-from-files-path'])) {
                $this->path .= sanitize_text_field($_COOKIE['gallery-from-files-path']); 
            }
        }
        $this->path = str_replace('|', DIRECTORY_SEPARATOR, $this->path);
    }

    function checkWriteable() {
        
        if (is_writeable($this->path)) {
            $this->is_writeable = true;
        } else {
            $this->is_writeable = false;
            $path = str_replace(GALLERY_FROM_FILES_595_WP_ROOT, '', $this->path);
            echo '<div class="notice notice-error">'.
                 '<p>' . sprintf( __('This folder not writeable! <em>(%s)</em>', 'gallery-from-files'), $path) . '</p>'.
                 '</div>';
        }
        
    }


    function getRouter() {
        $route = array();

        $path = str_replace(GALLERY_FROM_FILES_595_WP_ROOT, '', $this->path);
        if (!empty($path)) { 
            $path = explode(DS, $path);
        }
        $route[] = '<span class="route-item" onclick="gallery_from_files_595_js_setViewPath(\'\');">' . __('Home', 'gallery-from-files') . '</span>';
        
        if (!empty($path)) {
            if (!class_exists ('JDovi42Files', false)) {
                include_once(dirname(__file__) .DS. 'jdovi42_files.php');
            }
            $p = array();
            foreach ($path as $item) {
                $tmp = new JDovi42Files(GALLERY_FROM_FILES_595_WP_ROOT . implode('|', $p));
                $title = $tmp->getTitle($item);

                $p[] = $item;
                $route[] = '<span class="route-item" onclick="gallery_from_files_595_js_setViewPath(\''.implode('|', $p).'\');">' . $title. '</span>';
            }
            
        }
        $route = __('Folder path', 'gallery-from-files') . ': ' . implode(' -> ', $route);
        return '<div class="gallery-route">' . $route . '</div>';
    }
    
    function getShortcode() {
        
        $folder = str_replace(GALLERY_FROM_FILES_595_WP_ROOT, '', $this->path);
        $folder = str_replace(DIRECTORY_SEPARATOR, '/', $folder);
        
        $html = '<div class="shortcode" style="margin:6px 0;">';
        
        $html .= 'Shortcode: <span class="code" data-folder="'.$folder.'"></span>'; 

        if (!class_exists('JDovi42Files')) {
            include_once(dirname(__file__) .DIRECTORY_SEPARATOR. 'jdovi42_files.php');
        }

        $source = new JDovi42Files(get_stylesheet_directory() . '/gallery-from-files');
        $tmp = $source->getFolders();        
        if (!empty($tmp)) {
            for ($i = 0; $i <= count($tmp)-1; $i++) {
            	$folders[$tmp[$i]['filename']] = 'Theme: ' . __($tmp[$i]['title'], 'gallery-from-files'); 
            }
        }

        $source = new JDovi42Files(GALLERY_FROM_FILES_595_ROOT . '/templates'); 
        $tmp = $source->getFolders();        
        if (!empty($tmp)) {
            for ($i = 0; $i <= count($tmp)-1; $i++) {
            	if (!isset($folders[$tmp[$i]['filename']])) {
                    $folders[$tmp[$i]['filename']] = __($tmp[$i]['title'], 'gallery-from-files'); 
            	}
            }
        }
        ksort($folders);

        $html .= '<select name="gallery_form_files_template" class="gallery_form_files_template">';
        foreach ($folders as $key => $value) {
            $html .= '<option value="'.$key.'"';
            if ($this->options['template'] == $key) {
               $html .= ' SELECTED';
            }
            $html .= '>'.$value.'</option>';
        }
        $html .= '</select>';

        
        $html .= '<button onclick="gallery_from_files_595_copy_to_clipboard();" type="button" class="button" style="margin-left:6px;" title="'.__('Copy to clipboard', 'gallery-from-files').'">'.
                 '<span class="dashicons dashicons-shortcode" style="margin-right:0;"></span>'.
                 '</button>';
        
        $html .= '</div>';
        return $html;
    }

    function getSortBy() {
        
        $values = array('set', 'name', 'date');
        $html = '<div class="gallery-admin-orderby">' .
                '<select name="order" onchange="this.form.submit();">';
        foreach ($values as $item) {
            $html .= '<option value="'.$item.'"';
            if ($this->options['order'] == $item) {
               $html .= ' SELECTED';
            }
            $html .= '>'.__($item.'_title', 'gallery-from-files').'</option>';
        }
        $html .= '<input type="hidden" name="page" value="gallery-from-files-setting-admin" />'.
                 '</select></div>';

        return $html;
    }

    function getSortOrder() {
        
        echo '<!-- ' . __('asc_title', 'gallery-from-files') . ' -->';
        echo '<!-- ' . __('desc_title', 'gallery-from-files') . ' -->';
        $values = array('asc', 'desc');
        $html = '<div class="gallery-admin-orderby">' .
                '<select name="orderby" onchange="this.form.submit();">';
        foreach ($values as $item) {
            $html .= '<option value="'.$item.'"';
            if ($this->options['orderby'] == $item) {
               $html .= ' SELECTED';
            }
            $html .= '>'.__($item.'_title', 'gallery-from-files').'</option>';
        }
        $html .= '<input type="hidden" name="page" value="gallery-from-files-setting-admin" />'.
                 '</select></div>';

        return $html;
    }


    function getTopBar()
    {
        $html = '<div class="functions-bar">' . "\r\n" .
                $this->getRouter() . "\r\n" . 
                $this->getShortcode() . "\r\n" .
                '<form action="options-general.php">' . "\r\n" .
                $this->getSortOrder() . "\r\n" .
                $this->getSortBy() . "\r\n" .
                '<input type="hidden" name="page" value="gallery-from-files-setting-admin" />'. "\r\n" .
                '</form>'. "\r\n";
        
        if ($this->is_writeable) {
            
            $html .= "\t" . '<div style="display: inline-block;float:right;">' . "\r\n" .
                     "\t\t" . '<button onclick="gallery_from_files_595_new_folder_box();" type="button" class="button button-secondary"><span id="add_new_folder_icon" class="dashicons dashicons-plus" style="margin-top:5px;"></span>&nbsp;'. __('Add new folder', 'gallery-from-files').'</button>' . "\r\n" .
                     "\t" . '</div>' . "\r\n";
        }               
                 
        $html .= "\t" . '<div style="clear:both"></div>' . "\r\n" .
                 '</div>';
        return $html;
    }

    function getContent()
    {
        if (!class_exists ('JDovi42Galleries', false)) {
            include_once(dirname(__file__) .DS. 'jdovi42_galleries.php');
        }

        $path = new JDovi42Galleries($this->path, $this->options['th_folder']);
        
        if (isset($this->options['order'])) {
            switch ($this->options['order']){ 
                case 'name':
                    $path->folderSort = 'sortByName';
                    $path->filesSort = 'sortByName';
                    break;
                
                case 'date':
                    $path->folderSort = 'sortByDate';
                    $path->folesSort = 'sortByName';
                    break;
                
                default :
            }
        }        
        if (isset($this->options['orderby'])) {
            $path->folderSortOrder = $this->options['orderby']; 
            $path->filesSortOrder = $this->options['orderby']; 
        }


        $path->addTilt(array('wp-admin', 'wp-includes'));
        $this->folders = $path->getFolders();
        $this->files = $path->getFiles();

        $folders = array();
        if (!empty($this->folders)) {
            foreach ($this->folders as $item) {
                $folders[] = gallery_from_files_595_getFolder($item, $this->path, $this->options, $this->is_writeable);
            }
        }
        $folders = implode("\r\n", $folders);
        
        $files = array();
        if (!empty($this->files)) {
            $index = 1;
            $counter = 1;
            foreach ($this->files as $item) {
                $files[] = gallery_from_files_595_getFiles($item, $this->path, $this->options, $index, $counter, $this->is_writeable);
                $index++;
                $counter++;
            }
        }
        $files = implode("\r\n", $files);
        
        
        $html = "\r\n" . 
                '<div class="functions-bar">' . "\r\n" . 
                "\t" . '<div id="gallery-content">' . "\r\n" .
                "\t\t" . '<ul id="folders" class="sortable list-unstyled" data-path="'.$this->path.'">' .
                            gallery_from_files_595_getUpFolder($this->path, $this->options) . "\r\n" .
                            $folders . "\r\n" .
                "\t\t" . '</ul>' . "\r\n" .
                "\t\t" . '<ul id="images" class="sortable list-unstyled" data-path="'.$this->path.'">' .
                            $files . "\r\n" .
                "\t\t" . '</ul>' . "\r\n" .
                "\t" . '</div>' . "\r\n" .
                "\t" . '<div style="clear:both;"></div>' . "\r\n" .
                '</div>';
        
        return $html;
    }

    function getFunctionsBar() {

        if (!$this->is_writeable) {
            return '';
        }
    
        $html = '<div class="functions-bar">' . "\r\n" .
                "\t" . '<div style="display: inline-block;">' . "\r\n" .
                "\t\t" . '<button id="button_select_all" onclick="gallery_from_files_595_select_all();" type="button" class="button button-secondary">' . "\r\n" .
                "\t\t\t" . '<img src="'.plugins_url( 'gallery-from-files/assets/images/check.png', GALLERY_FROM_FILES_595_ROOT).'" />' . "\r\n" .
                "\t\t\t" . __('Select all', 'gallery-from-files') . "\r\n" .
                "\t\t" . '</button>' . "\r\n" .
                "\t\t" . '<button id="button_unselect_all" onclick="gallery_from_files_595_unselect_all();" type="button" class="button button-secondary">' . "\r\n" .
                "\t\t\t" . '<img src="'.plugins_url( 'gallery-from-files/assets/images/uncheck.png', GALLERY_FROM_FILES_595_ROOT).'" />' . "\r\n" .
                "\t\t\t" . __('Unselect all', 'gallery-from-files') . "\r\n" .
                "\t\t" . '</button>' . "\r\n" .
                "\t" . '</div>' . "\r\n" .
                "\t\t" . '<div style="float: right;border-left: 1px solid #ccc;margin-left:10px;padding-left:10px;">' . "\r\n" .
                "\t\t\t" . '<button id="button_delete_selected" onclick="gallery_from_files_595_selected_delete();" type="button" class="button button-secondary">' . "\r\n" .
                "\t\t\t\t" . '<span id="group_delete_icon" class="dashicons dashicons-trash"></span>' . "\r\n" .
                "\t\t\t\t" . __('Delete', 'gallery-from-files') . "\r\n" .
                "\t\t\t" . '</button>' . "\r\n" .
                "\t\t" . '</div>' . "\r\n" .
                "\t\t" . '<div style="float: right;">' . "\r\n" .
                "\t\t\t" . '<button id="button_rename_selected" onclick="gallery_from_files_595_groupTitles();" type="button" class="button button-secondary">' . "\r\n" .
                "\t\t\t\t" . '<span id="group_title_icon" class="dashicons dashicons-admin-comments"></span>' . "\r\n" .
                "\t\t\t\t" . __('Titles', 'gallery-from-files') . "\r\n" .
                "\t\t\t" . '</button>' . "\r\n" .
                "\t\t\t" . '<button id="button_rotate_left" onclick="gallery_from_files_595_rotateLeft();" type="button" class="button button-secondary">' . "\r\n" .
                "\t\t\t\t" . '<span id="rotate_left_icon" class="dashicons dashicons-image-rotate-left"></span>' . "\r\n" .
                "\t\t\t\t" . __('Rotate left', 'gallery-from-files') . "\r\n" .
                "\t\t\t" . '</button>' . "\r\n" .
                "\t\t\t" . '<button id="button_rotate_right" onclick="gallery_from_files_595_rotateRight();" type="button" class="button button-secondary">' . "\r\n" .
                "\t\t\t\t" . '<span id="rotate_right_icon" class="dashicons dashicons-image-rotate-right"></span>' . "\r\n" .
                "\t\t\t\t" . __('Rotate rigth', 'gallery-from-files') . "\r\n" .
                "\t\t\t" . '</button>' . "\r\n";
                
        if ($this->options['size'] != '') {                
            $html .= "\t\t\t" . '<button id="button_resize_selected" onclick="gallery_from_files_595_resize();" type="button" class="button button-secondary">' . "\r\n" .
                     "\t\t\t\t" . '<span id="group_resize_icon" class="dashicons dashicons-image-crop"></span>' . "\r\n" .
                     "\t\t\t\t" . __('Resize', 'gallery-from-files') . "\r\n" .
                     "\t\t\t" . '</button>' . "\r\n";
        }
        $html .= "\t\t\t" . '<button id="button_thumbnail_selected" onclick="gallery_from_files_595_generateThumbnails();" type="button" class="button button-secondary">' . "\r\n" .
                 "\t\t\t\t" . '<span id="generate_thumbnail_icon" class="dashicons dashicons-format-gallery"></span>' . "\r\n" .
                 "\t\t\t\t" . __('Generate thumbnails', 'gallery-from-files') . "\r\n" .
                 "\t\t\t" . '</button>' . "\r\n"; 

        if ($this->options['watermark'] != '') {
            $html .= "\t\t\t" . '<button id="button_watermark_selected" onclick="gallery_from_files_595_generateWatermarks();" type="button" class="button button-secondary">' . "\r\n" .
                     "\t\t\t\t" . '<span id="generate_watermark_icon" class="dashicons dashicons-format-image"></span>' . "\r\n" .
                     "\t\t\t\t" . __('Set watermark', 'gallery-from-files') . "\r\n" .
                     "\t\t\t" . '</button>' . "\r\n";
        }                
        $html .= "\t" . '</div>' . "\r\n" .
                 "\t" . '<div style="clear: both;"></div>' . "\r\n" .
                 '</div>';
        return $html;
    }

    function getUploadBar() {

        if (!$this->is_writeable) {
            return '';
        }
        
        $html = '<div class="functions-bar">' . "\r\n" .
                "\t" . '<form id="images_upload" method="post" enctype="multipart/form-data">' . "\r\n" .
                "\t\t" . '<label for="myfile">'. __('Select images', 'gallery-from-files').':</label>' . "\r\n" .
                "\t\t" . '<input type="file" class="input" id="myfile" name="myfile[]" multiple="multiple" accept=".jpg,.png,.tif,.gif"  />' . "\r\n" .
                "\t\t" . '<input type="submit" class="button button-secondary" value="'. __('Upload selected images', 'gallery-from-files').'" />' . "\r\n" .
                "\t\t" . '<input type="hidden" name="action" value="gallery_from_files_595_fileupload" />' . "\r\n" .
                "\t\t" . '<input type="hidden" name="filesName" value="myfile" />' . "\r\n" .
                "\t\t" . '<input type="hidden" name="allowExt" value="gif,png,jpg" />' . "\r\n" .
                "\t\t" . '<input type="hidden" name="maxSize" value="0" />' . "\r\n" .
                "\t\t" . '<input type="hidden" name="uploadDir" value="'.$this->path.'" />' . "\r\n" .
                "\t\t" . '<input type="hidden" name="size" value="'.$this->options['size'].'" />' . "\r\n" .
                "\t\t" . '<input type="hidden" name="th_folder" value="'.$this->options['th_folder'].'" />' . "\r\n" .
                "\t\t" . '<input type="hidden" name="th_size" value="'.$this->options['th_size'].'" />' . "\r\n";
        if ($this->options['watermark'] != '') {
            $upload = wp_get_upload_dir();
            $html .= "\t\t" . '<input type="hidden" name="watermark" value="'.$upload['basedir'] .DS. $this->options['watermark'].'" />' . "\r\n";
        } else {
            $html .= "\t\t" . '<input type="hidden" name="watermark" value="" />' . "\r\n";
        }
        $html .= "\t" . '</form>' . "\r\n" .
                 "\t" . '<div id="err"></div>' . "\r\n" .
                 '</div>' . "\r\n";
        return $html;
    }

    function getGauge()
    {
        $html = '<div id="gallery-job-gauge">' . "\r\n" .
                "\t" . '<div class="wait-message" style="text-align: center;">'.__('Job process running...', 'gallery-from-files').'</div>' . "\r\n" .
                "\t" . '<div class="gauge-line" style="text-align: center;">' . "\r\n" .
                "\t\t" . '<div style="width: 206px;display:inline-block;border:1px solid #0071a1;padding:2px;">' . "\r\n" .
                "\t\t\t" . '<div class="gauge" style="float:left;height:16px;background-color:#0071a1;width:114px;"></div>' . "\r\n" .
                "\t\t" . '</div>' . "\r\n" .
                "\t" . '</div>' . "\r\n" .
                "\t" . '<div class="percent" style="text-align: center;">57%</div>' . "\r\n" .
                "\t" . '<div class="wait-image" style="text-align: center;">' . "\r\n" .
                "\t\t" . '<img src="'.plugins_url( 'gallery-from-files/assets/images/wait.gif', GALLERY_FROM_FILES_595_ROOT).'" />' . "\r\n" .
                "\t" . '</div>' . "\r\n" .
                '</div>' . "\r\n" . 
                '<div id="gallery_get_name" style="display:none;">' . "\r\n" .
                '<form id="title_box" action="#">' . 
                "\t" . '<div style="text-align:left;">' . "\r\n" .
                "\t\t" . '<label class="gallery_get_title_label" for="gallery_get_title"></label>' . "\r\n" .
                "\t\t" . '<input id="gallery_get_title" type="text" value="" style="width:100%;" />' . "\r\n" .
                "\t\t" . '<hr />' . "\r\n" .
                "\t\t" . '<div class="message_functions" style="text-align:right">' . "\r\n" .
                "\t\t\t" . '<input onclick="gallery_from_files_595_hideTitleBox();" type="button" class="button button-secondary" value="'.__('Cancel').'" />' . "\r\n" .
                "\t\t" . '</div>' . "\r\n" .
                "\t" . '</div>' . "\r\n" .
                '</form>' . 
                '</div>' . "\r\n";
        return $html;
    }

    function getCropModal()
    {
        $html = 
            '<div id="gallery_crop_image" title="'.__('Image crop and save', 'gallery-from-files').'" style="display:none;width:600px;max-heigh:400pxmargin-top:20px;">' . "\r\n" .
            '    <div id="crop-info" class="small" style="text-align:left;margin-top:6px;">' . "\r\n" .
            '    </div>' . "\r\n" .
            '    <div class="crop-image-buttons" style="text-align: right;margin-top:6px;">' . "\r\n" .
            '        <input id="save-crop-image" onclick="gallery_from_files_595_saveCropImage();" type="button" class="button button-primary" value="'.__('Save').'" />' . "\r\n" .
            '        <input onclick="gallery_from_files_595_hide_crop();" type="button" class="button" value="'.__('Cancel').'" />' . "\r\n" .
            '        <input type="hidden" id="crop-image-id" name="crop-image-id" value="" />' . "\r\n" .
            '        <input type="hidden" id="crop-image-path" name="crop-image-path" value="" />' . "\r\n" .
            '        <input type="hidden" id="crop-image-name" name="crop-image-name" value="" />' . "\r\n" .
            '    </div>' . "\r\n" .
            '</div>' . "\r\n";
        
        return $html;
    }


    function render()
    {
        $html = '';
        $html .= $this->checkWriteable() .
                 $this->getTopBar() .
                 $this->getContent() . 
                 $this->getFunctionsBar() .
                 $this->getUploadBar() .
                 $this->getGauge() . 
                 $this->getCropModal();
        
        echo $html;
    }
}