<?php

    if ( !defined( 'ABSPATH' ) ) exit;
   
?>
<h3><?php echo __('Import images from posts and pages', 'gallery-from-files');?></h3>
<div><?php echo __('Modify default WordPress gallery shortcodes and move images to target folder.', 'gallery-from-files');?></div>
<div style="margin-top: 20px;">
    <label for="gallery_from_files_target"><?php echo __('Target folder', 'gallery-from-files');?></label>
    <input type="text" id="gallery_from_files_target" value="" style="width: 300px;" /><br />
    <?php echo __('A folder relative to the main folder in WordPress where you copy the images. <em>(Each gallery will be in a separate folder.)</em>', 'gallery-from-files');?>
</div>

<?php

	global $wpdb;
    $table_name = $wpdb->prefix . 'posts';

    $where = array();
    $where[] = '`post_type` IN ("post", "page")'; 
    $where[] = '`post_status` = "publish"'; 
    $where[] = '`post_content` LIKE "%[gallery %]%"'; 
    $where = implode(' AND ', $where);
    
    $sql = 'SELECT `ID`, `post_type`, `post_title`, `post_content` FROM ' . $table_name . ' WHERE '.$where;
    $pages = $wpdb -> get_results($sql);
    
?>
<table class="import-table" data-trash="<?php echo MEDIA_TRASH;?>">
    <thead>
    <tr>
        <th><?php echo __('ID');?></th>
        <th><?php echo __('Title');?></th>
        <th><?php echo __('Info');?></th>
        <th style="text-align:right">
            <?php if (!empty($pages)) : ?>
            <button type="button" onclick="gallery_from_files_595_importAll();" class="import-all-button button"><?php echo __('Import all', 'gallery-from-files');?></button>
            <div id="import_gauge">
                <div id="import_gauge_display"></div>
            </div>
            <?php endif; ?>
        </th>
    </tr>
    </thead>
    <tbody>
    <?php
    foreach ($pages as $page) {
        
        $images = array();
        $regex = "/\[gallery \s*.*?]/i";
        preg_match_all( $regex, $page->post_content, $matches, PREG_SET_ORDER);
        for ($i = 0; $i <= count($matches)-1; $i++) {
            preg_match_all('/(ids)="([^"]*)"/i',$matches[$i][0], $imgs);
            $imgs = explode(',', $imgs[2][0]);
            $images = array_unique(array_merge($imgs, $images));
        }
        
        echo '<tr id="content_'.$page->ID.'" data-id="'.$page->ID.'" data-images="'.implode(',', $images).'">'.
             '<td class="postid small">'.$page->post_type.':'.$page->ID.'</td>'.
             '<td>'.$page->post_title.'</td>'.
             '<td class="small">['.count($matches).' ' . __('Gallery') .', '.count($images).' ' . __('Image') .']</td>' . 
             '<td style="text-align:right"><button type="button" class="import-button button">'.__('Import').'</button></td>'.
             '</tr>';
    }
    ?>
    <?php if (empty($pages)) : ?>
    <tr>
        <td colspan="4" style="text-align: center;">
            <?php echo __('Nothing galleries in content', 'gallery-from-files');?>
        </td>
    </tr>
    <?php endif; ?>
    </tbody>
</table>
<?php 
if (!MEDIA_TRASH) {
    echo '<span style="color:red"><strong>' . __('Media trash is disabled!', 'gallery-from-files') . '</strong></span>' .
         '<div>' . __('Media Trash is not allowed, so it is not possible to delete images after importing.', 'gallery-from-files') . '</div>' .
         '<div>' . __('You can enable trash by placing the <code>define("MEDIA_TRASH", true);</code> entry in the wp-config.php file.', 'gallery-from-files') . '</div>';    
}

    